/*
 * Copyright (C) 2003   
 * paranoy project - paranoy.sf.net - paranoy@autistici.org
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */

#include "include.h"


/*
 * crea un nuovo account
 * create a new account 
 */
void
add_account()
{
  char email[51], user[31], pass[31], server[31], cs[10];
  ushort port = 0, proto, opt;

  echo();


  mvwprintw(wdata, 0, 0, " Enter the user: ");
  wgetnstr(wdata, user, 30);
  if (user[0] == 0)
  {
    clear_w(wdata, 0);
    wrefresh(wdata);
    return;
  }
  // I need it after
  if (strstr(user, "@"))
    opt = 1;
  else
    opt = 0;

  wprintw(wdata, " Enter the password [enter don't save]: ");
  noecho();
  pass[0] = '\0';
  wgetnstr(wdata, pass, 30);

  echo();
  opt ? wprintw(wdata, " Enter the pop server [%s]: ",
                strstr(user, "@") + 1) : wprintw(wdata,
                                                 " Enter the pop server [autistici.org]: ");
  wgetnstr(wdata, server, 30);
  if (server[0] == 0)
  {
    if (opt)
      strcpy(server, strstr(user, "@") + 1);
    else
      strcpy(server, "autistici.org");

  }
  if (server[0] == '0')
    strcpy(server, "127.0.0.1");

  if (opt)
    wprintw(wdata, " Enter your email [%s]: ", user);
  else
    wprintw(wdata, " Enter your email [%s@%s]: ", user, server);
  wgetnstr(wdata, email, 50);
  if (email[0] == 0)
  {
    if (opt)
      sprintf(email, "%s", user);
    else
      sprintf(email, "%s@%s", user, server);
  }
  do
  {
    wprintw(wdata, "\n 0] autoprobe for supported protocol\n");
    wprintw(wdata,
            " 1] pop3+apop or user/pass on unsuccess (clear connection)\n");
    wprintw(wdata,
            " 2] pop3+apop or user/pass on unsuccess (ssl connection)\n");
    wprintw(wdata, " 3] pop3+ssl+apop (stop on unsuccess)\n");
    wprintw(wdata, " 4] imap (clear connection)\n");
    wprintw(wdata, " 5] imap+ssl\n");
    wprintw(wdata, " Enter the protocol do you want to be used [2]: ");
    wgetnstr(wdata, cs, 1);
    if (cs[0] == 0)
      strcpy(cs, "2");
    proto = atoi(cs);
  }
  while (proto > 5);

  if (!proto)
  {
    if (!(proto = autoprobe(server, user, (char *) NULL, &port)))
    {
      clear_w(wdata, 0);
      wrefresh(wdata);
      info(2, "Error while making account\n");
      return;
    }
  } else
  {
    do
    {
      wprintw(wdata, " Enter the port [");
      switch (proto)
      {
        case 1:
          wprintw(wdata, "%d]: ", POP3_PORT);
          break;
        case 2:
        case 3:
          wprintw(wdata, "%d]: ", POP3S_PORT);
          break;
        case 4:
          wprintw(wdata, "%d]: ", IMAP_PORT);
          break;
        case 5:
          wprintw(wdata, "%d]: ", IMAPS_PORT);
          break;
      }

      wgetnstr(wdata, cs, 5);

      if (cs[0] == 0)
      {
        switch (proto)
        {
          case 1:
            port = POP3_PORT;
            break;
          case 2:
          case 3:
            port = POP3S_PORT;
            break;
          case 4:
            port = IMAP_PORT;
            break;
          case 5:
            port = IMAPS_PORT;
            break;
        }
      } else
        port = atoi(cs);


    }
    while (!port);
  }
  do
  {
    wprintw(wdata, " Delete emails from server [N/y]: ");
    wgetnstr(wdata, cs, 2);
    if (cs[0] == 0)
      cs[0] = 'n';
  }
  while (cs[0] != 'y' && cs[0] != 'n');

  opt = cs[0] == 'y' ? 1 : 0;

  wprintw(wdata, "\n");

  /*
   * aggiunge l'account alla lista 
   * add the account to list
   */
  if (naccount == 0)
  {
    account = (struct accountlist **) malloc(sizeof(struct accountlist *));
    account[0] = (struct accountlist *) malloc(sizeof(struct accountlist));
    naccount++;
  } else
  {
    account =
      (struct accountlist **) realloc(account,
                                      sizeof(struct accountlist *) *
                                      naccount + 1);
    account[naccount] =
      (struct accountlist *) malloc(sizeof(struct accountlist));
    naccount++;
  }

  account[naccount - 1]->user = (char *) malloc(strlen(user) + 1);
  strcpy(account[naccount - 1]->user, user);


  if (pass[0] == 0)
  {
    account[naccount - 1]->nopass = 1;
    account[naccount - 1]->pass = NULL;
  } else
  {
    account[naccount - 1]->nopass = 0;
    account[naccount - 1]->pass = _malloc(strlen(pass) + 1);
    _mempcpy(account[naccount - 1]->pass, pass, strlen(pass));
  }

  account[naccount - 1]->host = (char *) malloc(strlen(server) + 1);
  strcpy(account[naccount - 1]->host, server);
  account[naccount - 1]->email = (char *) malloc(strlen(email) + 1);
  strcpy(account[naccount - 1]->email, email);

  account[naccount - 1]->port = port;
  account[naccount - 1]->proto = proto;
  logg("nel nuovo account il proto e' : %d\n", proto);
  account[naccount - 1]->opt = opt;

  logg("l'account creato e' %s@%s:%d\n", account[naccount - 1]->user,
       account[naccount - 1]->host, account[naccount - 1]->port);

  noecho();
  // wprintw(wdata, "Account succesfull added\n");
  info(2, "Account succesfull added!\n");
  clear_w(wdata, 0);
  wrefresh(wdata);
}


// del the account number n
byte
del_account(short n)
{
  int i;
  char c = ' ';

  clear_w(wdata, 0);
  wattrset(wdata, A_REVERSE);
  mvwprintw(wdata, 5, 3, account[n]->email);
  wattrset(wdata, A_NORMAL);
  curs_set(2);
  while (c != 'y')
  {
    mvwprintw(wdata, 8, 3, "Are you sure? [n\\y]");
    wrefresh(wdata);
    c = wgetch(wdata);

    if (c == 'n')
    {
      clear_w(wdata, 0);
      wrefresh(wdata);
      return 1;
    }

  }
  curs_set(0);

  clear_w(wdata, 0);
  wrefresh(wdata);

  naccount--;
  // se nn ci sono piu' account libera
  if (naccount == 0)
  {
    free(account);
    return 0;
  } else
  {

    // cancella elemento spostando gli el degli array
    for (i = n; i < naccount; i++)
      account[i] = account[i + 1];

    account =
      (struct accountlist **) realloc(account,
                                      sizeof(struct accountlist *)
                                      * naccount);
  }

  info(2, " Account deleted!");

  return 1;

}

void
list_account()
{
  byte mod = 0;
  short sel = 0, old = 0, i;


  for (i = 0; i < naccount; i++)
    mvwprintw(wdata, 5 + i, 3, account[i]->email);

  while (sel != 100)
  {
    curs_set(0);
    wattrset(wdata, A_NORMAL);
    mvwprintw(wdata, 3, 3, "- Account%c", naccount > 1 ? 's' : ' ');

    // se un account e' stato modificato aggiorna wdata
    if (mod)
    {
      // logg("dentro ristampa accountzz mod=%d naccount=%d\n", mod,
      // naccount);
      for (i = 0; i < naccount; i++)
        mvwprintw(wdata, 5 + i, 3, account[i]->email);

      mod = 0;
    }
    // aggiorna selezione
    if (net_optimize)
    {
      mvwprintw(wdata, old + 5, 2, " ");
      mvwprintw(wdata, sel + 5, 2, ">");
    } else
    {
      wattrset(wdata, A_NORMAL);
      mvwprintw(wdata, old + 5, 3, account[old]->email);
      wattrset(wdata, A_REVERSE);
      mvwprintw(wdata, sel + 5, 3, account[sel]->email);
    }
    logg("dopo ristampa selezione\n");
    wrefresh(wdata);

    switch (getch())
    {
      case KEY_RIGHT:
      case ENTER:
      case 13:
        edit_account(account[sel]);
        break;
      case KEY_DOWN:
        old = sel;
        if (sel == naccount - 1)
          sel = 0;
        else
          sel++;
        break;
      case KEY_UP:
        old = sel;
        if (sel == 0)
          sel = naccount - 1;
        else
          sel--;
        break;
      case 'q':
      case ESC:
      case KEY_LEFT:
        sel = 100;
        break;
      case 'c':
      case KEY_DC:
        mod = del_account(sel);
        // se nn ci sono piu' account esce
        if (!mod)
        {
          sel = 100;
          info(2, "No Account");
          break;
        }
        if (sel == naccount)
          sel = 0;
        break;
    }


  }
  clear_w(wdata, 0);
  wrefresh(wdata);
  return;
}

void
edit_account(struct accountlist *temp)
{
  char *menu[] =
    { "User:", "Password:", "Email address:", "Server:", "Port:", "Protocol:",
    "Delete from server:"
  };
  ushort i, old = 0, sel = 0;
  ushort nelements = 7;
  char *porta = (char *) malloc(sizeof(char) * 10);

  clear_w(wdata, 0);
  wrefresh(wdata);
  snprintf(porta, 9, "%d", temp->port);


  logg("dentro l'edit account dell'utente '%s' -> %d\n", temp->email,
       temp->proto);

  mvwprintw(wdata, 3, 3, "-[ %s ]-", temp->email);
  // printa il menu, l'user la mail e l'host
  for (i = 0; i < nelements; i++)
  {
    mvwprintw(wdata, i + 5, 5, "%s", menu[i]);
    mvwprintw(wdata, i + 5, 25, "%s",
              i == 0 ? temp->user : i == 1 ? "" : i == 2 ? temp->email : i ==
              3 ? temp->host : i == 4 ? porta : i == 5 ? (temp->proto ==
                                                          POP3_CLEAR_PROTO ?
                                                          "Clear POP3" :
                                                          temp->proto ==
                                                          POP3_SSL_PROTO ?
                                                          "SSL POP3" : temp->
                                                          proto ==
                                                          POP3_FORCE_SSL_PROTO
                                                          ?
                                                          "SSL POP3 (forced)"
                                                          : temp->proto ==
                                                          IMAP_CLEAR_PROTO ?
                                                          "Clear IMAP" :
                                                          "SSL IMAP") : i ==
              6 ? (temp->opt ? "YES" : "NO") : "");
  }

  // printa gli * della password TODO (la pass e' _mallocata)


  logg("qui prima del while\n");
  while (1)
  {
    if (net_optimize)
    {
      mvwprintw(wdata, old + 5, 4, " ");
      mvwprintw(wdata, sel + 5, 4, ">");
    } else
    {
      wattrset(wdata, A_NORMAL);
      mvwprintw(wdata, old + 5, 5, menu[old]);
      wattrset(wdata, A_REVERSE);
      mvwprintw(wdata, sel + 5, 5, menu[sel]);
      wattrset(wdata, A_NORMAL);

    }
    wrefresh(wdata);
    switch (getch())
    {
        // accedo ad un campo per modificarlo
      case ENTER:
      case KEY_RIGHT:
      case 32:
        {
          char *p =
            sel == 0 ? temp->user : sel == 4 ? porta : sel ==
            2 ? temp->email : sel == 3 ? temp->host : NULL;
          if (p)
          {
            logg("nell'edit string\n");
            p = edit_string(p, sel + 5, 25, wdata);
            logg("before refresh pointers\n");

            // refresh pointer
            switch (sel)
            {
              case 0:
                temp->user = p;
                break;
              case 2:
                temp->email = p;
                break;
              case 3:
                temp->host = p;
                break;
              case 4:
                temp->port = atoi(p);
                break;
            }

          } else if (sel == 5)
          {
            switch (temp->proto)
            {
              case POP3_CLEAR_PROTO:
                temp->proto = POP3_SSL_PROTO;
                mvwprintw(wdata, 10, 25, "SSL POP3\n");
                break;
              case POP3_SSL_PROTO:
                temp->proto = POP3_FORCE_SSL_PROTO;
                mvwprintw(wdata, 10, 25, "SSL POP3 (forced)\n");
                break;
              case POP3_FORCE_SSL_PROTO:
                temp->proto = IMAP_CLEAR_PROTO;
                mvwprintw(wdata, 10, 25, "Clear IMAP\n");
                break;
              case IMAP_CLEAR_PROTO:
                temp->proto = IMAP_SSL_PROTO;
                mvwprintw(wdata, 10, 25, "SSL IMAP\n");
              case IMAP_SSL_PROTO:
                temp->proto = POP3_CLEAR_PROTO;
                mvwprintw(wdata, 10, 25, "Clear POP3\n");

                break;
            }
            wrefresh(wdata);
          }
        }
        break;
      case KEY_DOWN:
        old = sel;
        if (sel == nelements - 1)
          sel = 0;
        else
          sel++;
        break;
      case KEY_UP:
        old = sel;
        if (sel == 0)
          sel = nelements - 1;
        else
          sel--;
        break;
      case 'q':
      case ESC:
      case KEY_LEFT:
        wattrset(wdata, A_NORMAL);
        clear_w(wdata, 0);
        return;
        break;
    }
  }
}


void
edit_contact(struct contacts *temp)
{
  int c;
  byte flag = 0;
  char *menu[3] = { "Nome", "Email", "Save" };
  char *s = NULL;
  short pos = 0, old = 0, i;

  for (i = 0; i < 3; i++)
    mvwprintw(wdata, 5 + i, 4, "%s%c", menu[i], i != 2 ? ':' : ' ');

  if (temp->name)
  {
    flag = 1;
    mvwprintw(wdata, 5, 10, "%s", temp->name);
  }

  if (temp->email)
    mvwprintw(wdata, 6, 11, "%s", temp->email);

  curs_set(0);
  while (pos != 100)
  {
    if (net_optimize)
    {
      mvwprintw(wdata, old + 5, 3, " ");
      mvwprintw(wdata, pos + 5, 3, ">");
    } else
    {
      wattrset(wdata, A_NORMAL);
      mvwprintw(wdata, old + 5, 4, menu[old]);
      wattrset(wdata, A_REVERSE);
      mvwprintw(wdata, pos + 5, 4, menu[pos]);
    }
    wrefresh(wdata);
    switch (c = wgetch(wdata))
    {
      case KEY_DOWN:
        old = pos;
        pos = pos != 2 ? pos + 1 : 0;
        break;

      case KEY_UP:
        old = pos;
        pos = pos != 0 ? pos - 1 : 2;
        break;

      case 'q':
      case ESC:
      case KEY_LEFT:
        pos = 100;
        break;

      case KEY_RIGHT:
      case ENTER:
        if (pos != 2)
        {
          if (pos == 1)
          {
            temp->email = edit_string(temp->email, 6, 11, wdata);
            logg("%s\n", temp->email);
          } else
          {
            temp->name = edit_string(temp->name, 5, 10, wdata);
            logg("%s\n", temp->name);
          }
          s = NULL;
        } else
        {
          if (!is_mail(temp->email))
          {
            info(2, "Insert valid e-mail address");
            break;
          }
          if (temp->name[0] != 0 && temp->email[0] != 0)
          {
            // verifica se hanno chiave pubblica
            if (!have_public_key(temp->email))
              temp->have_key = PUB;

            else
              temp->have_key = NO;

            // here edit the contacts
            if (!flag)
            {
              if (contact != NULL)
                temp->next = contact;
              else
                temp->next = NULL;
              contact = temp;
            }
            info(2, "Contact saved! (With%s public key)!",
                 temp->have_key == PUB ? "" : "out");
          } else
            info(2, "Contact not saved");


          pos = 100;
        }
        break;

      default:
        ungetch(c);
        ungetch(ENTER);
        break;
    }
  }

  return;

}


void
add_contact()
{
  struct contacts *temp;
  temp = (struct contacts *) malloc(sizeof(struct contacts));
  temp->email = (char *) malloc(50 * sizeof(char));
  temp->name = (char *) malloc(50 * sizeof(char));
  temp->name = NULL;
  temp->email = NULL;


  mvwprintw(wdata, 3, 2, "- New account ");
  edit_contact(temp);

  clear_w(wdata, 0);
  wrefresh(wdata);
  return;
}


void
list_contact()
{
  struct contacts *temp = contact;

  // struct contacts *pos,*old;
  int len = 0;
  short pos = 0, old = 0, j = 0;
  byte mod = 0;

  // temp=old=pos=contact;

  while (temp)
  {
    if (temp->have_key == PUB)
      wattrset(wdata, COLOR_PAIR(COLOR_HAVEKEY));
    else
      wattrset(wdata, A_NORMAL);
    mvwprintw(wdata, len + 3, 3, "-= %s =- %s", temp->name, temp->email);
    len++;
    temp = temp->next;
  }
  temp = contact;
  while (pos != 100)
  {
    logg("all'inizio while princ");
    // se c'e' stata una modifica prima ristampa
    if (mod)
    {
      while (temp)
      {
        logg("dentro while di ristampa");
        if (temp->have_key == PUB)
          wattrset(wdata, COLOR_PAIR(COLOR_HAVEKEY));
        else
          wattrset(wdata, A_NORMAL);

        mvwprintw(wdata, len + 3, 3, "-= %s =- %s", temp->name, temp->email);
        len++;
        temp = temp->next;
      }
      temp = contact;
      mod = 0;
    }

    logg("dopo ristampa");
    if (net_optimize)
    {
      mvwprintw(wdata, old + 3, 2, " ");
      mvwprintw(wdata, pos + 3, 2, ">");
    } else
    {
      for (j = 0; j < old; j++)
        temp = temp->next;
      wattrset(wdata, A_NORMAL);
      if (temp->have_key == PUB)
        wattron(wdata, COLOR_PAIR(COLOR_HAVEKEY));
      mvwprintw(wdata, old + 3, 3, "-= %s =- %s", temp->name, temp->email);
      temp = contact;
      for (j = 0; j < pos; j++)
        temp = temp->next;
      wattrset(wdata, A_REVERSE);
      if (temp->have_key == PUB)
        wattron(wdata, COLOR_PAIR(COLOR_HAVEKEY));
      mvwprintw(wdata, pos + 3, 3, "-= %s =- %s", temp->name, temp->email);
      temp = contact;
    }

    logg("dopo controllo selezione");
    wrefresh(wdata);
    switch (getch())
    {

        // delete a contact
      case 'd':
      case KEY_DC:

        break;

        // esci
      case 'q':
      case ESC:
      case KEY_LEFT:
        pos = 100;
        break;

      case KEY_UP:
        old = pos;
        if (pos != 0)
          pos--;
        else
          pos = len - 1;
        break;

      case KEY_DOWN:
        old = pos;
        if (pos != len - 1)
          pos++;
        else
          pos = 0;
        break;

      case ENTER:
        {
          mod = 1;
          clear_w(wdata, 0);
          wrefresh(wdata);
          mvwprintw(wdata, 3, 2, "- Edit account ");

          short j;

          for (j = 0; j != pos; j++)
            temp = temp->next;


          edit_contact(temp);
          clear_w(wdata, 0);
          wrefresh(wdata);
          info(2, "name: %s  email: %s", temp->name, temp->email);
          temp = contact;

          break;

        }
      default:
        logg("nello switch");
        break;
    }
  }
  clear_w(wdata, 0);
  wrefresh(wdata);
  return;
}



void
new_filter()
{
  char buff[BUFFER_REAL];
  struct filters *temp;
  struct rules *rul;

  curs_set(2);
  echo();

  // ask the name of filter
  wprintw(wdata, " Insert the name of filter: ");
  wgetnstr(wdata, buff, BUFFER_LEN);

  temp = (struct filters *) smalloc(sizeof(struct filters));
  temp->name = strdup(buff);
  rul = temp->head = (struct rules *) smalloc(sizeof(struct rules));

  while (1)
  {

    // insert rules
    wprintw(wdata, "______________________________\n\n");
    wprintw(wdata, " Where I have to search in: ");
    wgetnstr(wdata, buff, BUFFER_LEN);
    rul->what = strdup(buff);

    wprintw(wdata, " What I have to search: ");
    wgetnstr(wdata, buff, BUFFER_LEN);
    rul->value = strdup(buff);

    if (strcasestr(rul->what, "size"))
      wprintw(wdata, " Must be: \n  1)Greater than\n  2)Lower than\n");
    else
      wprintw(wdata,
              " Must : \n  1)Contain\n  2)Not contain\n  3)Be equal to\n  4)Be not equal to\n");

    wprintw(wdata, "\n Choose: ");
    wgetnstr(wdata, buff, BUFFER_LEN);

    if (strcasestr(rul->what, "size"))
      rul->parse = atoi(buff) + 4;
    else
      rul->parse = atoi(buff);
    // end rules

    wprintw(wdata,
            " Add a rule to this filter:\n 0)None\n 1)And\n  2)Or\n Choose: ");
    wgetnstr(wdata, buff, BUFFER_LEN);
    rul->after = atoi(buff);
    if (rul->after)
    {
      rul->next = (struct rules *) smalloc(sizeof(struct rules));
      rul = rul->next;
      mvwprintw(wdata, 2, 1, "");
    } else
      break;
  }

  rul->next = NULL;


  // action
  wprintw(wdata,
          " What I have to do if match:\n  1)Move\n  2)Copy\n  3)Delete\n  4)Forward\n Choose: ");
  wgetnstr(wdata, buff, BUFFER_LEN);
  temp->action = atoi(buff);

  if (temp->action != DELETE)
  {
    wprintw(wdata, " Where i have to %s this: ",
            (temp->action == COPY) ? "copy" : (temp->action ==
                                               MOVE ? "move" : "forward"));
    wgetnstr(wdata, buff, BUFFER_LEN);
    temp->where = strdup(buff);
  } else
    temp->where = NULL;


  // add the filter to list
  if (!filt)
  {
    logg("primo filtro\n");
    filt = temp;
    filt->next = NULL;
  } else
  {
    temp->next = filt;
    filt = temp;
  }



  noecho();
  curs_set(0);

  return;
}




void
cur_gen_key_callback(void *self, const char *what, int type, int current,
                     int total)
{
  wprintw(wdata, "*");
  wrefresh(wdata);
}


void
cur_gen_key()
{
  char length[6];
  char name[31];
  char comment[31];
  char email[31];
  char passphrase[64];
  char passphrase_conf[64];

  echo();

  if (!mode)
  {
    do
    {
      wprintw(wdata, " Please select the length of the key: ");
      wgetnstr(wdata, length, 5);
    }
    while (atoi(length) == 0);
  } else
    // default lenght
    strcpy(length, "1024");
  do
  {
    wprintw(wdata, " Insert your name: ");
    wgetnstr(wdata, name, 30);
  }
  while (strlen(name) < 1);
  wprintw(wdata, " Insert a comment: ");
  wgetnstr(wdata, comment, 30);
  do
  {
    wprintw(wdata, " Insert the email for this key: ");
    wgetnstr(wdata, email, 30);
  }
  while (FALSE);                // !valid_email(email));

  noecho();
  do
  {
    wprintw(wdata, " Insert the %s for this key: ",
            mode ? "password" : "passphrase");
    wgetnstr(wdata, passphrase, 30);
    wprintw(wdata, " Reinsert the %s for this key: ",
            mode ? "password" : "passphrase");
    wgetnstr(wdata, passphrase_conf, 30);
  }
  while (strlen(passphrase) < 1 || strcmp(passphrase, passphrase_conf));

  gen_key(name, comment, email, passphrase, atoi(length));

}



void
create_nym_account()
{
  /*
   * char length[6]; char name[31]; char nymserver[31]; char passphrase[31];
   * char passphrase_conf[31]; char s[4096]; char *reply_block; struct email
   * mail;
   * 
   * if (naccount == 0) { info(1, "Impossible create nym account without a
   * real account!"); return; }
   * 
   * if (!mode) { do { wprintw(wdata, " Please select the length of the key
   * for nym server: "); wgetnstr(wdata, length, 5); } while (atoi(length) == 
   * 0); } else // default lenght strcpy(length, "1024"); do { wprintw(wdata, 
   * " Insert the name of your nym account: "); wgetnstr(wdata, name, 30); }
   * while (strlen(name) < 1); do { wprintw(wdata, " Insert the nym server to 
   * use: "); wgetnstr(wdata, nymserver, 30); } while (FALSE); //
   * !valid_email(email));
   * 
   * noecho(); do { wprintw(wdata, " Insert the %s for this key: ", mode ?
   * "password" : "passphrase"); wgetnstr(wdata, passphrase, 30);
   * wprintw(wdata, " Reinsert the %s for this key: ", mode ? "password" :
   * "passphrase"); wgetnstr(wdata, passphrase_conf, 30); } while
   * (strlen(passphrase) < 1 || strcmp(passphrase, passphrase_conf));
   * 
   * // make gpg pair of key for nym server gen_key(name, NULL, nymserver,
   * passphrase, atoi(length));
   * 
   * // create reply block
   * 
   * snprintf(s, 4095, "::\nAnon-To: %s@%s\nLatent-time: %s\nEncrypt_key:
   * %s\n", account[0]->user, account[0]->host, latent_time, passphrase); //
   * reply_block = gpg_encrypt(s, nymserver);
   * 
   * put_body(&mail, reply_block); put_before_body(&mail, "::\nEncrypted:
   * PGP\n\n"); snprintf(s, 4095, "Config:\nFrom: %s\nNym-Commands: create
   * +acksend +fingerkey\nPublic-Key:\n\n", name); put_before_body(&mail, s);
   * mail.to = (char **) malloc(sizeof(char *)); mail.to[0] = (char *)
   * malloc(strlen(nymserver) + 9); sprintf(mail.to[0], "config@%s",
   * nymserver); // create_chain(mail); 
   */
}


void
title(const char *str, ...)
{
  char *s;
  va_list ap;

  va_start(ap, str);
  s[vasprintf(&s, str, ap)] = '\0';
  va_end(ap);
  wattrset(wtop, COLOR_PAIR(COLOR_TITLE));
  mvwaddstr(wtop, 0, 0, "  ");
  mvwprintw(wtop, 0, 2, s);
  while (waddstr(wtop, " ") != ERR);
  wattrset(wtop, A_NORMAL);
  wrefresh(wtop);
  free(s);
}


void
get_color(short pair)
{
  byte i;

  short tfg, tbg;

  pair_content(pair, &tfg, &tbg);

  // se pos>9 siamo nel secondo menu'
  byte pos = 0;
  byte old = 0;

  // stampa 2 barre verticali colorate
  // impostando i colori selezionati
  wattrset(wdata, COLOR_PAIR(pair));
  mvwprintw(wdata, 1, 3, "-= Foreground -=- Background =-");
  wattrset(wdata, A_NORMAL);
  for (i = 1; i < 9; i++)
  {
    mvwprintw(wdata, i * 2 + 1, 10, "[");
    wattrset(wdata, COLOR_PAIR(i));
    mvwprintw(wdata, i * 2 + 1, 11, i - 1 == tfg ? "X" : " ");
    wattrset(wdata, A_NORMAL);
    mvwprintw(wdata, i * 2 + 1, 12, "]          [");
    wattrset(wdata, COLOR_PAIR(i));
    mvwprintw(wdata, i * 2 + 1, 24, i - 1 == tbg ? "X" : " ");
    wattrset(wdata, A_NORMAL);
    mvwprintw(wdata, i * 2 + 1, 25, "]");
  }

  while (1)
  {
    // disseleziono la voce precedentemente selezionata
    if (old > 9)
      mvwprintw(wdata, (old - 10) * 2 + 3, 22, " ");
    else
      mvwprintw(wdata, old * 2 + 3, 8, " ");

    // seleziono la nuova voce
    if (pos > 9)
      mvwprintw(wdata, (pos - 10) * 2 + 3, 22, ">");
    else
      mvwprintw(wdata, pos * 2 + 3, 8, ">");

    wrefresh(wdata);
    switch (wgetch(wdata))
    {
      case KEY_UP:
        if (pos != 0 && pos != 10)
        {
          old = pos;
          pos--;
        }
        break;

      case KEY_DOWN:
        if (pos != 7 && pos != 17)
        {
          old = pos;
          pos++;
        }
        break;

      case KEY_LEFT:
        // se sono nella seconda finestra e premo sinistra
        // deve tornare nella prima
        if (pos > 9)
        {
          old = pos;
          pos -= 10;
          break;
        }


      case 'q':
      case ESC:
        // qui devo fare il mega switch
        switch (pair)
        {
          case COLOR_NEW:
            cnew_fore = tfg;
            cnew_back = tbg;
            break;
          case COLOR_OLD:
            cold_fore = tfg;
            cold_back = tbg;
            break;
          case COLOR_TITLE:
            ctitle_fore = tfg;
            ctitle_back = tbg;
            break;
          case COLOR_INFO:
            cinfo_fore = tfg;
            cinfo_back = tbg;
            break;
          case COLOR_QUOTE1:
            cquote1_fore = tfg;
            cquote1_back = tbg;
            break;
          case COLOR_QUOTE2:
            cquote2_fore = tfg;
            cquote2_back = tbg;
            break;
          case COLOR_QUOTE3:
            cquote3_fore = tfg;
            cquote3_back = tbg;
            break;
          case COLOR_HAVEKEY:
            chavekey_fore = tfg;
            chavekey_back = tbg;
            break;
          case COLOR_TOYOU:
            ctoyou_fore = tfg;
            ctoyou_back = tbg;
            break;
          case COLOR_DELETE:
            cdelete_fore = tfg;
            cdelete_back = tbg;
            break;
        }

        init_pair(pair, tfg, tbg);
        return;
        break;

        // se sono nel primo menu' passo al secondo
      case KEY_RIGHT:
        if (pos < 9)
        {
          old = pos;
          pos += 10;
        }
        break;


      case ENTER:
      case 'x':
      case 'X':
      case SPACE:


        if (pos > 9)
        {
          // nascondo la selezione precedente
          wattrset(wdata, COLOR_PAIR(tbg + 1));
          mvwprintw(wdata, (tbg + 1) * 2 + 1, 24, " ");

          tbg = pos - 10;

          // seleziono la nuova scelta
          wattrset(wdata, COLOR_PAIR(tbg + 1));
          mvwprintw(wdata, (tbg + 1) * 2 + 1, 24, "X");


        } else
        {

          // nascondo la selezione precedente
          wattrset(wdata, COLOR_PAIR(tfg + 1));
          mvwprintw(wdata, (tfg + 1) * 2 + 1, 11, " ");

          tfg = pos;


          // seleziono la nuova scelta
          wattrset(wdata, COLOR_PAIR(tfg + 1));
          mvwprintw(wdata, (tfg + 1) * 2 + 1, 11, "X");

        }
        init_pair(COLOR_TEMP, tfg, tbg);
        wattrset(wdata, COLOR_PAIR(COLOR_TEMP));
        mvwprintw(wdata, 1, 3, "-= Foreground -=- Background =-");
        wattrset(wdata, A_NORMAL);
        break;
    }

  }



  wgetch(wdata);
  wrefresh(wdata);
}


void
set_color()
{

  char *menu[] =
    { "New mail", "Readed mail", "Title bar", "Information bar", "Quote 1",
    "Quote 2", "Quote 3", "Have public key", "Mail is to you",
    "Deleted mail"
  };
  byte pos = 0, old = 0;
  int i;

  curs_set(0);
  // print the menu the first time
  for (i = 0; i < 10; i++)
  {
    wattrset(wdata, COLOR_PAIR(i + 10));
    mvwprintw(wdata, i + 2, 3, menu[i]);
  }

  while (1)
  {
    // cancella la selezione precedente
    wattrset(wdata, A_NORMAL);
    wattron(wdata, COLOR_PAIR(old + 10));
    mvwprintw(wdata, old + 2, 3, menu[old]);

    // stampa la nuova selezione
    wattrset(wdata, A_REVERSE);
    wattron(wdata, COLOR_PAIR(pos + 10));
    mvwprintw(wdata, pos + 2, 3, menu[pos]);

    switch (wgetch(wdata))
    {
      case KEY_DOWN:
        old = pos;
        if (pos < 9)
          pos++;
        else
          pos = 0;
        break;

      case KEY_UP:
        old = pos;
        if (pos > 0)
          pos--;
        else
          pos = 9;
        break;

      case KEY_LEFT:
      case 'q':
      case ESC:
        clear_w(wdata, 0);
        wrefresh(wdata);
        return;
        break;

      case KEY_RIGHT:
      case ENTER:
      case SPACE:

        clear_w(wdata, 0);
        wrefresh(wdata);

        get_color(pos + 10);

        clear_w(wdata, 0);
        // reprint the menu
        for (i = 0; i < 10; i++)
        {
          wattrset(wdata, COLOR_PAIR(i + 10));
          mvwprintw(wdata, i + 2, 3, menu[i]);
        }
        break;

      default:
        break;
    }

  }
}


void
print_line(WINDOW * win, ushort y, char *l)
{
  byte a, b;

  a = b = 0;
  while (l[a] == ' ' || l[a] == '>')
  {
    if (l[a] == '>')
      b++;
    a++;

  }
  if (b)
  {

    b = (b - 1) % 3;
    wattrset(win, COLOR_PAIR(b + 13));
  } else
    wattrset(win, A_NORMAL);
  logg("dentro print_line sto scrivendo le robe\n");
  mvwprintw(win, y, 1, l);

  if (b)
    wattrset(win, A_NORMAL);
}



char *
edit_string(char *str, byte y, byte x, WINDOW * win)
{
  struct contacts *tmp;
  ushort i;

  wattrset(win, A_NORMAL);

  // keep the cursor position and the len of the edited string
  ushort pos, len;
  int c;
  char *s = NULL;

  // move the cursor at last character
  pos = strlen(str ? str : "");

  // now the cursor flash
  curs_set(1);

  // edited string is not new
  if (str)
  {
    len = pos;
    s = (char *) malloc(sizeof(char) * (len + 1));
    memcpy(s, str, len);
    s[len] = 0;
    free(str);
  } else
  {
    len = 0;
    s = (char *) malloc(sizeof(char));
    s[len] = 0;
  }



  do
  {
    // reprint edited string
    mvwprintw(win, y, x, "%s", s);
    // move the curses
    mvwprintw(win, y, x + pos, "");
    wrefresh(win);

    switch (c = wgetch(win))
    {
        // key left
      case KEY_LEFT:
        if (pos > 0)
          pos--;
        break;
        // key right
      case KEY_RIGHT:
        if (pos < len)
          pos++;
        break;

        // enter
      case 13:
      case 10:
        ungetch(KEY_DOWN);
        curs_set(0);
        return s;

        // backspace
      case 127:
      case KEY_BACKSPACE:
        if (pos > 0)
        {
          if (len == 1)
          {
            len = 0;
            pos--;
            s = (char *) realloc(s, 1);
            s[len] = 0;
            mvwprintw(win, y, x + len, " ");
          } else
          {
            s = (char *) realloc(s, len);
            pos--;
            len--;
            s[len] = 0;
            mvwprintw(win, y, x + len, " ");
            for (i = pos + 1; i < len; i++)
              s[i - 1] = s[i];
          }

        }
        break;

      case KEY_DOWN:
      case KEY_UP:
        curs_set(0);
        ungetch(c);
        return s;

        // canc
      case KEY_DC:
        if (pos < len)
        {
          if (len == 1)
          {
            len = 0;
            s = (char *) realloc(s, sizeof(char));
            s[len] = 0;
            mvwprintw(win, y, x + len, " ");
          } else
          {
            s = (char *) realloc(s, len * sizeof(char));
            for (i = pos + 1; i < len; i++)
              s[i - 1] = s[i];
            len--;
            mvwprintw(win, y, x + len, " ");
            s[len] = 0;
          }
        }
        break;

        // tab
      case 9:
        if (contact == NULL)
          break;
        tmp = contact;
        if (s != NULL)
          while (tmp != NULL)
          {
            if (!strncmp(s, tmp->name, len) || !strncmp(s, tmp->email, len))
            {
              free(s);
              len = strlen(tmp->email);
              pos = len;
              s = (char *) malloc(len + 1);
              memcpy(s, tmp->email, len);
              s[len] = 0;
              if (tmp->have_key == PUB)
                wattron(wcompose, COLOR_PAIR(COLOR_HAVEKEY));
              break;
            }
            tmp = tmp->next;
          }
        break;
      default:
        pos++;
        len++;
        s = (char *) realloc(s, (len + 1));
        s[pos - 1] = c;
        s[len] = 0;
        break;
    }
  }
  while (1);
  return NULL;
}


// clear the specified window (if border is true, don't delete the border)
void
clear_w(WINDOW * win, byte border)
{
  ushort x, y, maxy, maxx;

  getmaxyx(win, maxy, maxx);
  wattrset(win, A_NORMAL);
  if (border)
    for (y = 2; y < maxy - 1; y++)
      for (x = 2; x < maxx - 1; x++)
        mvwprintw(win, y, x, " ");
  else
    for (y = 0; y <= maxy; y++)
      for (x = 0; x <= maxx; x++)
        mvwprintw(win, y, x, " ");

  // put the cursor at the begin of the win
  mvwprintw(win, 0, 0, "");
}
