/*
 * + Copyright (C) 2003 paranoy project - paranox.sf.net -
 * paranoy@autistici.org This program is free software; you can redistribute 
 * it and/or modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.  This program is
 * distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
 * PARTICULAR PURPOSE.  See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc., 59
 * Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 */

#include "include.h"
#include "curses.h"

#define CHARS	81


void
edit()
{
  ushort x, y, l, ins, real, refresh, nlines; // only 256 lines??
  struct lines *realm = NULL, *line = NULL;
  int c;
  char buff[CHARS];

  logg("sono dentro edit\n");
  if (!text)
  {
    text = (struct lines *) malloc(sizeof(struct lines));
    text->data = (char *) malloc(sizeof(char) * CHARS);
    text->data = NULL;
    text->prev = NULL;
    text->next = NULL;
    text->l = 0;
    nlines = 1;
    realm = line = text;
  } else
    for (line = text, nlines = 0; line->next; line = line->next, nlines++);

  line = text;
  refresh = ins = real = y = x = 0;
  mvwprintw(weditor, y, x, "");
  wrefresh(weditor);

  logg("dentro edit\n");

  if (line->data != NULL)
  {
    strcpy(buff, line->data);
    l = line->l;
    buff[l] = 0;
  } else
  {
    buff[0] = 0;
    l = 0;
  }

  // print all lines (debugging...)
  while (line->next)
  {
    logg("[%d] %p '%s'\n", line->l, line->next, line->data);
    line = line->next;
  }
  line = text;

  curs_set(1);
  while (1)
  {
    // resfresh
    if (!refresh)
      // only line's resfreh
    {
      print_line(weditor, y - real, buff[0] ? buff : "");
      wrefresh(weditor);
    }

    mvwprintw(weditor, 0, COLS - 12, "[%c %2d/%2d] %d", ins ? '-' : 'I', x, y,
              nlines);
    switch (c = mvwgetch(weditor, y - real, x + 1))
    {
      case -1:
        break;
      case KEY_DOWN:
        // at the last line
        if (!line->next)
          info(1, " Already at the end of message");
        else                    // in the middle TODO
        {
          logg("sono qui dentro\n");
          line->data = (char *) realloc(line->data, sizeof(char) * (l + 1));
          buff[l] = 0;
          if (l)
            strcpy(line->data, buff);

          line->l = l;
          line = line->next;
          if (line->data)
            strcpy(buff, line->data);
          else
            buff[0] = 0;

          y++;
          // if cursor is over last position
          if (x >= line->l)
            l = x = line->l;
          else
            l = line->l;

          if (y - real == LINES - (naccount + 18))
          {
            realm = realm->next;
            real++;
            print_text(realm, 0, nlines);
            wrefresh(weditor);
          }

        }
        break;

      case KEY_UP:

        if (!y || !line->prev)
          return;

        logg("premo up\n");
        // save the current line
        line->data = (char *) realloc(line->data, sizeof(char) * (l + 1));
        buff[l] = 0;
        if (l)
          strcpy(line->data, buff);

        logg
          ("dopo l'strcpy il buff della riga prima era '%s' con l = %d e y = %d e line->prev = %p\n",
           line->data, l, y, line->prev);
        line->l = l;

        y--;
        line = line->prev;
        logg("la nuova line contiene '%s' con l = %d\n", line->data, line->l);
        if (line->data)
          strcpy(buff, line->data);
        else
          buff[0] = 0;
        logg("dopo l'strcpy\n");
        // if cursor is over last position
        if (x >= line->l)
          l = x = line->l;
        else
          l = line->l;

        logg("prima dell'if\n");
        if (y + 1 == real)
        {
          realm = realm->prev;
          real--;
          print_text(realm, 0, nlines);
          wrefresh(weditor);
        }


        break;

      case KEY_LEFT:
        logg("dentro key left\n");
        if (x > 0)
          x--;

        // we have to go to the prev line
        else
        {
          if (y > 0)
          {
            line->data = (char *) realloc(line->data, sizeof(char) * (l + 1));
            buff[l] = 0;
            if (l)
              strcpy(line->data, buff);
            line->l = l;
            y--;
            line = line->prev;
            if (line->data)
              strcpy(buff, line->data);
            else
              buff[0] = 0;
            l = x = line->l;
          }
        }
        break;
      case KEY_RIGHT:
        logg("dentro key right\n");
        if (x < l)
          x++;
        // we have to go to the next line
        else
        {
          if (line->next == NULL)
          {
            logg("dentro il keydown\n");
            info(1, " Already at the end of message");
          } else
          {
            logg("dentro il keydown nell'else\n");
            line->data = (char *) realloc(line->data, sizeof(char) * (l + 1));
            buff[l] = 0;
            if (l)
              strcpy(line->data, buff);
            line->l = l;
            line = line->next;
            if (line->data)
              strcpy(buff, line->data);
            else
              buff[0] = 0;
            l = line->l;
            x = 0;
            y++;
          }
        }
        break;

      case KEY_BACKSPACE:
      case 127:
        if (x > 0)
        {
          x--;
          l--;
          // we have to delete the last char
          if (x == l)
          {
            mvwprintw(weditor, y, x, " ");
            wrefresh(weditor);
            buff[x] = 0;
          } else
          {

            line->l = x;
            for (; x < l; x++)
              buff[x] = buff[x + 1];
            buff[l] = 0;
            x = line->l;
            mvwprintw(weditor, y, l, " ");
            wrefresh(weditor);
          }
        }
        break;

      case KEY_DC:
        // we r in buff's middle
        if (x < l)
        {
          l--;
          line->l = x;
          for (; x < l; x++)
            buff[x] = buff[x + 1];
          buff[l] = 0;
          x = line->l;
          mvwprintw(weditor, y, l, " ");
          wrefresh(weditor);

        }
        break;

      case KEY_IC:
        ins = ins ? 0 : 1;
        break;

      case KEY_END:
        x = l;
        break;

      case KEY_HOME:
        x = 0;
        break;

      case ENTER:
        // enter in the midle
        if (x < l)
        {
          int i;

          line->l = x;
          logg("dentro ENTER buff == %s\n", buff);
          line->data = (char *) realloc(line->data, sizeof(char) * (l + 2));
          strcpy(line->data, buff);
          // line->data =
          // (char *) realloc(line->data, sizeof(char) * (line->l + 2));
          logg("dopo cpy\n");
          line->data[x] = '\n';
          line->data[x + 1] = 0;
          mvwprintw(weditor, y - real, 0, line->data);
          wrefresh(weditor);
          for (i = 0; x < l; x++, i++)
            buff[i] = buff[x];

          l = i;
          x = 0;
          buff[l] = 0;
        } else
        {
          logg("dentro l'enter\n");
          buff[x] = '\n';
          buff[x + 1] = 0;
          line->l = x + 1;
          line->data = (char *) realloc(line->data, sizeof(char) * (l + 2));
          // use memcpy

          strcpy(line->data, buff);
          x = l = 0;
          buff[x] = 0;
        }


        // add a line at the last position
        if (line->next == NULL)
        {
          logg("addo una line \n");
          line->next = (struct lines *) malloc(sizeof(struct lines));
          line->next->prev = line;
          line = line->next;
          line->data = (char *) malloc(sizeof(char));
          *line->data = 0;
          // line->data = NULL;
          line->next = NULL;
          l = line->l = 0;
          logg(" nlines = %d , %d\n", nlines, LINES);
          if (nlines - real == LINES - (naccount + 18))
          {
            logg("edit - sono all'ultima riga\n");
            realm = realm->next;
            real++;
            print_text(realm, 0, nlines);
            wrefresh(weditor);
            refresh();
          }
        } else                  // insert a line between 2 lines
        {
          logg("insenter\n");
          struct lines *n = (struct lines *) malloc(sizeof(struct lines));

          n->prev = line;
          n->next = line->next;
          line->next = n;
          n->data = (char *) malloc(sizeof(char));
          line->data = NULL;
          n->l = l;
          line = n;
        }
        nlines++;
        y++;
        break;

        // TODO 
      case KEY_NPAGE:
        break;

        // TODO
      case KEY_PPAGE:
        break;

        // postpone TODO...i know i know it's all still to do but one day....
      case CTRLO:
        ungetch(ENTER);
        break;
        // send 
      case CTRLX:
        ungetch(ENTER);
        ungetch(KEY_UP);
      case ESC:
        line->l = l + 1;
        line->data = (char *) realloc(line->data, sizeof(char) * l + 2);
        strcpy(line->data, buff);
        line->data[l] = '\n';
        line->data[l + 1] = 0;
        return;

      default:
        if (x == l)
        {
          buff[x] = c;
          buff[x + 1] = 0;
          l++;
        } else
        {
          if (ins)
            buff[x] = c;
          else
          {
            line->l = l;
            for (; l > x; l--)
              buff[l] = buff[l - 1];
            buff[x] = c;
            l = line->l;
            buff[l + 2] = 0;
            l++;
            logg(" %s buffer\n", buff);
          }
        }
        x++;

        // if we haven't more space in the line
        if (l == CHARS - 2)
        {

          // if there is a char ' ' in the line carriage
          if (strchr(buff, ' '))
          {


            for (; buff[l] != ' '; l--)
              buff[l + 2] = buff[l];

            buff[l] = '\n';
            buff[l + 1] = 0;

            line->l = l;
            line->data = (char *) realloc(line->data, sizeof(char) * l + 2);
            strcpy(line->data, buff);

            mvwprintw(weditor, y - real - 1, 0, buff);
            wrefresh(weditor);
            l += 3;
            for (x = 0; l < CHARS; l++, x++)
              buff[x] = buff[l];

            x--;

          }
          // only 1 word in the line 
          else
          {
            buff[l] = 0;
            line->data = (char *) realloc(line->data, sizeof(char) * l + 1);
            strcpy(line->data, buff);
            x = 0;
          }

          nlines++;
          buff[x] = 0;

          // if it's the last line
          if (line->next == NULL)
          {
            line->next = (struct lines *) malloc(sizeof(struct lines));
            line->next->prev = line;
            line = line->next;
            line->data = (char *) malloc(sizeof(char));
            *line->data = 0;
            line->next = NULL;
            line->l = 0;
            y++;
            l = x;
            break;
          } else                // TODO
          {
            line = line->next;
            if (line->l < CHARS - x) // if it's the last word inline
            {
              strcat(buff, line->data);
              y++;
              l = line->l;
            } else              // in the middle of line
            {
              strcpy(buff, line->data);
              y++;
              l = line->l;
              x = 0;
            }
          }
          break;
        }
    }
  }
}

// reprint text from head line
void
print_text(struct lines *head, ushort first, int nline)
{
  ushort y = first;

  logg("DENTRO print_text\n");
  if (head)
  {
    print_line(weditor, y, head->data);
    while (head->next)
    {
      y++;
      head = head->next;
      print_line(weditor, y, head->data);
      // mvwprintw(weditor, y, 0, head->data);
    }
    mvwprintw(weditor, y, 0, "\n");
  }
}
