#include <stdio.h>
#include <time.h>
#include <sys/time.h>

static const char *weekday_names[] = {
	"Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"
};

const char *month_names[] = {
	"Jan", "Feb", "Mar", "Apr", "May", "Jun",
	"Jul", "Aug", "Sep", "Oct", "Nov", "Dec", NULL
};



char *
nexttoken(char *cp)
{
	for (;;) 
    {
		if (*cp == '\0')
			return NULL;
		if (*cp == ' ') 
        {
          cp++;
      	  return cp;
        }
        cp++;
    }
}


struct tm*
rfctime(char *date)
{
	char *cp = date, *x;
    struct tm *t;
    
	int i;

    t=(struct tm*)malloc(sizeof(struct tm));
	if ((cp = nexttoken(cp)) == NULL)
      return NULL;
	if (cp[0]<127 && cp[1] <127 && cp[2]<127 && cp[3] == ',') {
		if ((cp = nexttoken(&cp[4])) == NULL)
			return NULL;
	}
	t->tm_mday = strtol(cp, &x, 10);
	if ((cp = nexttoken(x)) == NULL)
      return NULL;
	for (i = 0; month_names[i]; i++) {
		if (strncmp(cp, month_names[i], 3) == 0)
			break;
	}
	if (month_names[i] == NULL)
		return NULL;
	t->tm_mon = i + 1;
	if ((cp = nexttoken(&cp[3])) == NULL)
		return NULL;
	t->tm_year = strtol(cp, &x, 10);
	if ((cp = nexttoken(x)) == NULL)
		 return NULL;
	t->tm_hour = strtol(cp, &x, 10);
	if (*x != ':')
      return NULL;
	cp = &x[1];
	t->tm_min = strtol(cp, &x, 10);
	if (*x == ':') {
		cp = &x[1];
		t->tm_sec = strtol(cp, &x, 10);
	} else
		t->tm_sec = 0;
/*
	if ((cp = nexttoken(x)) != NULL) {
		int sign = -1;
		char buf[3];

		switch (*cp) {
		case '-':
			sign = 1;
		case '+':
			cp++;
		}
		if (cp[0]<127 && cp[1]<127 && cp[2]<127 && cp[3] < 127) {
			buf[2] = '\0';
			buf[0] = cp[0];
			buf[1] = cp[1];
			t += strtol(buf, NULL, 10) * sign * 3600;
			buf[0] = cp[2];
			buf[1] = cp[3];
			t += strtol(buf, NULL, 10) * sign * 60;
		}
	}
*/
	return t;
}

int main()
{
  struct tm *t=rfctime("Tue, 13 Apr 2004 16:49:57 +0200");
  printf("%d/%d/%d\n",t->tm_mday,t->tm_mon,t->tm_year);

  
}