//mail threading experiment
#include <stdio.h>

struct lista
{
  struct mail *mail;
  struct lista *next,*prec;
} *lista;


struct mail 
{
  char *id;
  char *reply;
  unsigned short int level;
};


void print_list()
{
  struct lista *tmp=lista;
  while(tmp->next)
  {
    unsigned short int i;
    for (i=0;i<tmp->mail->level;i++,printf(" "));
    printf("%s -> %s\n",tmp->mail->id,tmp->mail->reply);
    tmp=tmp->next;
}
  printf("\n\n\n\nal contrario\n\n\n\n");
  while(tmp)
  {
    unsigned short int i;
    for (i=0;i<tmp->mail->level;i++,printf(" "));
    printf("%s -> %s\n",tmp->mail->id,tmp->mail->reply);
    tmp=tmp->prec;
  }
}

void addmail(const char *id,const char *reply)
{
  struct  lista *search,*n;
  
  //crea il nuovo messaggio
  struct mail *temp=(struct mail * )malloc(sizeof(struct mail));
  temp->id=(char *)strdup(id);
  temp->reply=(char *)strdup(reply);
  temp->level=0;
  
  if (!lista)
  {
    lista=(struct lista *)malloc(sizeof(struct lista));
    lista->next=NULL;
    lista->prec=NULL;
    lista->mail=temp;
    return;
  }
  search=lista;
  while(search)
  {
    if (!strcmp(search->mail->id,reply))
      break;
    search=search->next;
  }
  
  n=(struct lista *)malloc(sizeof(struct lista));
  n->mail=temp;

  if (!search)
  {
    n->next=lista;
    lista->prec=n;
    n->prec=NULL;
    lista=n;
  }
  else
  {
    n->mail->level=search->mail->level+1;
    if (search->next)
      search->next->prec=n;
    n->next=search->next;
    search->next=n;
    n->prec=search;
  }
}

int main()
{
  lista=NULL;
  addmail("1","0");
  addmail("2","0");
  addmail("3","0");
  addmail("4","0");
  addmail("5","2");
  addmail("6","1");
  addmail("7","1");
  addmail("8","1");
  addmail("9","6");
  addmail("10","9");
  addmail("11","2");


  print_list();
}


