/*
 * Copyright (C) 2003  
 * paranoy project - paranox.sf.net - paranoy@autistici.org
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */

#include "include.h"


// print the usage if the -h option is called
void
usage()
{
  fprintf(stderr, "\n - paranoy %s -\n\n", VERSION);
  fprintf(stderr, "  Usage:\n\n");
  fprintf(stderr,
          "  -g | --gui curses/gtk\t\tselect graphic user interface\n");
  fprintf(stderr, "  -c | --compose\t\tdirectly compose an email\n");
  fprintf(stderr, "  -v | --version\t\tshow paranoy version\n");
  fprintf(stderr, "  -h | --help\t\t\tthis help\n\n");
}

#ifdef USE_CURSES
void
help(const char *where)
{
  char buffer[BUFFER_REAL];
  FILE *file;
  ushort x = 0, i, a;
  char **line = NULL;
  line = (char **) malloc(sizeof(char *));
  wattroff(wmain, A_REVERSE);
  scrollok(wmain, TRUE);
  snprintf(buffer, BUFFER_LEN, "%s/.help", MAILDIR);
  logg("apro il file di help %s\n", buffer);
  if ((file = fopen(buffer, "r")) == NULL)
  {
    info(1, "Error while reading help file!");
    return;
  }
  // arrivo al punto desiderato
  while (strcmp(buffer, where))
  {
    fgets(buffer, BUFFER_LEN, file);
    buffer[strlen(buffer) - 1] = 0;
    logg("Dentro help devo trovare '%s' trovo '%s'\n", where, buffer);
    if (feof(file))
    {
      info(1, "Error while reading help file");
      return;
    }
  }

  clear_w(wmain, 0);
  logg("ok....sono arrivato dove dovevo...si dia inizio alle danze\n");
  // carica il buffer
  while (1)
  {

    fgets(buffer, BUFFER_LEN, file);
    strip(buffer, '\n');
    if (!strcmp(buffer, "end"))
      break;
    // alloca una nuova riga
    line = (char **) realloc(line, sizeof(char *) * (x + 1));
    line[x] = (char *) malloc(strlen(buffer) + 1);
    strcpy(line[x], buffer);
    logg("Leggo il buffer %s\n", buffer);
    x++;
  }
  fclose(file);
  logg("finito di caricare il buffer\n");
  a = i = 0;
  refresh();
  for (a = 0; a < x && a < LINES - 4; a++)
    mvwprintw(wmain, a + 1, 1, line[a]);
  wrefresh(wmain);
  while (1)
  {

    // riprinta lo skermo
    switch (getch())
    {
      case KEY_DOWN:
        if (i < x - LINES + 4)
        {
          wscrl(wmain, 1);
          mvwprintw(wmain, LINES - 5, 1, line[LINES - 4 + i]);
          i++;
          wrefresh(wmain);

        }
        break;
      case KEY_UP:
        if (i > 1)
        {
          wscrl(wmain, -1);
          mvwprintw(wmain, 0, 1, line[i - 2]);
          i--;
          wrefresh(wmain);
        }
        break;

      case 27:
      case 'q':
      case KEY_LEFT:
        clear_w(wmain, 0);
        return;
        break;
    }
  }

}
#endif
