/*
 * ripped from somaplayer (somaplayer.realityhacking.org) 
 */
#include "../include.h"
// #include "about_logo.xpm"

static const char *credits[] = {
  "lesion\n<lesion@autistici.org>\nCoder and Mantainer",
  "drama\n<drama@neuroni.org>\nGtk Coder and Zen Supporter",
  "bakunin\n<baku@autistici.org>\nCoder",
  "ginox\n<ginox@autistici.org>\nImap support's Coder",
  "arlan\n<arlan@indivia.net>\nMoral supporter",
  NULL
};

static int about_t = 0;
static int about_timer = 0;
static GtkWidget *texto = NULL;

gint about_timeout(gpointer);
void on_about_button_press_event(GtkWidget *, GdkEventButton *);

void
on_about_activate(GtkWidget * item, gpointer user_data)
{

  static GtkWidget *window = NULL;

  if (!window)
  {
    GtkWidget *hbox, *vbox;
    GtkWidget *image;
    GtkWidget *scrolledwindow;
    GtkWidget *textarea;
    GtkWidget *eventbox;
    GdkColor color;
    char path[300];


    gdk_color_parse("black", &color);
    window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
    gtk_widget_realize(window);
    gtk_window_set_position(GTK_WINDOW(window), GTK_WIN_POS_CENTER_ALWAYS);
    // gdk_window_set_decorations (window->window, 0);

    vbox = gtk_vbox_new(FALSE, 0);
    gtk_widget_show(vbox);
    gtk_container_add(GTK_CONTAINER(window), vbox);

    eventbox = gtk_event_box_new();
    gtk_widget_show(eventbox);

    hbox = gtk_hbox_new(FALSE, 0);
    gtk_widget_realize(hbox);
    gtk_widget_modify_bg(eventbox, GTK_STATE_NORMAL, &color);

    gtk_widget_show(hbox);
    gtk_container_add(GTK_CONTAINER(vbox), eventbox);
    gtk_container_add(GTK_CONTAINER(eventbox), hbox);



    snprintf(path, 299, "%s/Themes/%s/p.gif", MAILDIR, THEME);
    image = gtk_image_new_from_file(path);
    gtk_widget_show(image);
    gtk_box_pack_start(GTK_BOX(hbox), image, TRUE, TRUE, 5);


    snprintf(path, 299, "%s/Themes/%s/a.gif", MAILDIR, THEME);
    image = gtk_image_new_from_file(path);
    gtk_widget_show(image);
    gtk_box_pack_start(GTK_BOX(hbox), image, TRUE, TRUE, 5);

    snprintf(path, 299, "%s/Themes/%s/r.gif", MAILDIR, THEME);
    image = gtk_image_new_from_file(path);
    gtk_widget_show(image);
    gtk_box_pack_start(GTK_BOX(hbox), image, TRUE, TRUE, 5);


    snprintf(path, 299, "%s/Themes/%s/a.gif", MAILDIR, THEME);
    image = gtk_image_new_from_file(path);
    gtk_widget_show(image);
    gtk_box_pack_start(GTK_BOX(hbox), image, TRUE, TRUE, 5);


    snprintf(path, 299, "%s/Themes/%s/n.gif", MAILDIR, THEME);
    image = gtk_image_new_from_file(path);
    gtk_widget_show(image);
    gtk_box_pack_start(GTK_BOX(hbox), image, TRUE, TRUE, 5);

    snprintf(path, 299, "%s/Themes/%s/o.gif", MAILDIR, THEME);
    image = gtk_image_new_from_file(path);
    gtk_widget_show(image);
    gtk_box_pack_start(GTK_BOX(hbox), image, TRUE, TRUE, 5);

    snprintf(path, 299, "%s/Themes/%s/y.gif", MAILDIR, THEME);
    image = gtk_image_new_from_file(path);
    gtk_widget_show(image);
    gtk_box_pack_start(GTK_BOX(hbox), image, TRUE, TRUE, 5);


    scrolledwindow = gtk_scrolled_window_new(NULL, NULL);
    gtk_widget_show(scrolledwindow);
    gtk_box_pack_start(GTK_BOX(vbox), scrolledwindow, FALSE, FALSE, 0);
    gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolledwindow),
                                   GTK_POLICY_AUTOMATIC,
                                   GTK_POLICY_AUTOMATIC);
    gtk_widget_set_size_request(scrolledwindow, -1, 100);

    textarea = gtk_text_view_new();
    gtk_widget_show(textarea);
    gtk_container_add(GTK_CONTAINER(scrolledwindow), textarea);
    gtk_text_view_set_editable(GTK_TEXT_VIEW(textarea), FALSE);
    gtk_text_view_set_justification(GTK_TEXT_VIEW(textarea),
                                    GTK_JUSTIFY_CENTER);
    gtk_text_view_set_cursor_visible(GTK_TEXT_VIEW(textarea), FALSE);
    gtk_text_view_set_pixels_above_lines(GTK_TEXT_VIEW(textarea), 5);
    gtk_text_view_set_pixels_below_lines(GTK_TEXT_VIEW(textarea), 5);
    gtk_text_view_set_left_margin(GTK_TEXT_VIEW(textarea), 5);
    gtk_text_view_set_right_margin(GTK_TEXT_VIEW(textarea), 5);

    texto = (GtkWidget *) gtk_text_view_get_buffer(GTK_TEXT_VIEW(textarea));
    gtk_text_buffer_create_tag(GTK_TEXT_BUFFER(texto), "text", "weight",
                               PANGO_WEIGHT_BOLD, "scale",
                               PANGO_SCALE_MEDIUM, NULL);

    g_signal_connect((gpointer) window, "delete_event",
                     G_CALLBACK(on_about_activate), texto);

    gtk_signal_connect_object(GTK_OBJECT(textarea), "button_press_event",
                              GTK_SIGNAL_FUNC
                              (on_about_button_press_event), textarea);

  }

  if (!user_data)
  {
    about_timer = 0;
    about_timeout(NULL);
    gtk_widget_show(window);

    about_t = g_timeout_add(2000, about_timeout, NULL);
  } else
  {
    if (about_t)
      g_source_remove(about_t);

    about_t = 0;

    gtk_widget_hide(window);
  }
}

void
on_about_button_press_event(GtkWidget * w, GdkEventButton * event)
{

  if (event->button == 3 && about_timer > 1)
    about_timer -= 2;

  g_source_remove(about_t);
  about_timeout(NULL);
  about_t = g_timeout_add(2000, about_timeout, NULL);
}

/*
 * Timeout for scrolling 
 */
gint
about_timeout(gpointer data)
{
  GtkTextIter start;
  GtkTextIter end;

  gtk_text_buffer_get_start_iter(GTK_TEXT_BUFFER(texto), &start);
  gtk_text_buffer_get_end_iter(GTK_TEXT_BUFFER(texto), &end);

  gtk_text_buffer_delete(GTK_TEXT_BUFFER(texto), &start, &end);

  gtk_text_buffer_get_iter_at_offset(GTK_TEXT_BUFFER(texto), &start, 0);


  if (!credits[about_timer])
    about_timer = 0;

  gtk_text_buffer_insert_with_tags_by_name(GTK_TEXT_BUFFER(texto),
                                           &start, credits[about_timer],
                                           -1, "text", NULL);
  about_timer++;

  return TRUE;
}
