#include "../include.h"

int
gtkmain(int argc, char *argv[])
{
  GtkWidget *main_window;
  char path[300];

#ifdef ENABLE_NLS
  bindtextdomain(GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
  bind_textdomain_codeset(GETTEXT_PACKAGE, "UTF-8");
  textdomain(GETTEXT_PACKAGE);
#endif

  gui = GTK;
  // g_thread_init(NULL);
  // gdk_threads_init();
  // gdk_threads_enter();

  // lunch thread that download email each n seconds
  // pthread_create(&sleep_thread, NULL, (void *) timed, NULL);

  // lunch info thread
  // pthread_mutex_init(&info_mutex, NULL);
  // pthread_cond_init(&info_cond, NULL);
  // pthread_create(&info_thread, NULL, (void *) infoz, NULL);


  gtk_set_locale();
  gtk_init(&argc, &argv);

  snprintf(path, 299, "%s/Themes/%s/gtkrc", MAILDIR, THEME);

  gtk_rc_parse(path);

  main_window = create_main_window();
  gtk_widget_show(main_window);
  gtk_signal_connect(GTK_OBJECT(main_window), "destroy",
                     GTK_SIGNAL_FUNC(gtk_main_quit), NULL);

  gtk_main();
  // gdk_threads_leave();
  return 0;
}
