#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "../include.h"

void
mail_renderer(GtkTreeViewColumn * col,
              GtkCellRenderer * renderer,
              GtkTreeModel * model, GtkTreeIter * iter, gpointer user_data)
{
  gboolean s;
  struct email *p;

  // gtk_misc_set_padding(col,0,0);

  // bad trick



  g_object_set(renderer, "size", 8000, "size-set", TRUE, NULL);


  gtk_tree_model_get(model, iter, MAIL_SORT, &s, -1);
  gtk_tree_model_get(model, iter, MAIL, &p, -1);

  if (p->type == NEW)
    g_object_set(renderer, "weight", PANGO_WEIGHT_BOLD, NULL);
  else
    g_object_set(renderer, "weight", PANGO_WEIGHT_NORMAL, NULL);

  // printf(" dentro il render s = %d -> %s\n",s,p->subject);

  if (s == TRUE)
    g_object_set(renderer, "background", "LightBlue", "background-set", TRUE,
                 NULL);
  else
    g_object_set(renderer, "background-set", FALSE, NULL);
}


GtkWidget *
create_main_window(void)
{
  GtkWidget *main_window;
  GtkWidget *main_vbox;
  GtkWidget *mainmenubar_hbox;
  GtkWidget *main_menubar;
  GtkWidget *hbox, *vbox, *out_vbox;
  GtkWidget *viewport;          // *table;
  GtkWidget *label;
  GtkWidget *main_hpaned;
  GtkWidget *scrolledwindow;
  GtkWidget *main_vpaned;
  GtkWidget *scrolledwindow4;
  GtkWidget *scrolledwindow5;
  GtkWidget *toolbar1;
  GtkWidget *selmail_textview;
  GtkTreeViewColumn *fold_col;
  GtkCellRenderer *fold_renderer;
  char path[300];


  GtkTreeIter mail_iter;
  GtkTreeIter fold_iter;
  GtkTreeViewColumn *mail_col;
  GtkCellRenderer *renderer;

  // GtkTreeSelection *sel;

  downloading = 0;

  current_fold = NULL;
  current_mail = NULL;

  pthread_cond_init(&pop3event, NULL);

  main_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_window_set_default_size(GTK_WINDOW(main_window),
                              gdk_screen_width() / 1.18,
                              gdk_screen_height() / 1.3);
  gtk_window_set_title(GTK_WINDOW(main_window), _(":: paranoy 0.8 ::"));
  gtk_widget_realize(main_window);


  snprintf(path, 299, "%s/Themes/%s/paranoy.png", MAILDIR, THEME);
  gtk_window_set_default_icon_from_file(path, NULL);
  main_vbox = gtk_vbox_new(FALSE, 0);
  gtk_widget_show(main_vbox);
  gtk_container_add(GTK_CONTAINER(main_window), main_vbox);

  mainmenubar_hbox = gtk_hbox_new(FALSE, 0);
  gtk_widget_show(mainmenubar_hbox);

  gtk_box_pack_start(GTK_BOX(main_vbox), mainmenubar_hbox, FALSE, FALSE, 0);

  hbox = gtk_hbox_new(FALSE, 0);
  gtk_widget_show(hbox);
  gtk_box_pack_start(GTK_BOX(main_vbox), hbox, TRUE, TRUE, 0);

  out_vbox = gtk_vbox_new(FALSE, 0);
  gtk_widget_show(out_vbox);
  gtk_box_pack_start(GTK_BOX(hbox), out_vbox, TRUE, TRUE, 0);

  scrolledwindow = create_utility_bar();
  gtk_widget_show(scrolledwindow);
  gtk_box_pack_start(GTK_BOX(out_vbox), scrolledwindow, FALSE, TRUE, 0);


  main_hpaned = gtk_hpaned_new();
  gtk_widget_show(main_hpaned);
  gtk_box_pack_start(GTK_BOX(out_vbox), main_hpaned, TRUE, TRUE, 0);
  gtk_paned_set_position(GTK_PANED(main_hpaned), 180);

  vbox = gtk_vbox_new(FALSE, 0);
  gtk_widget_show(vbox);
  gtk_paned_pack1(GTK_PANED(main_hpaned), vbox, FALSE, FALSE);

  // qui bisogna capire come cazzo fare per farlo visualizzare tutto
  // all'inizio...

  scrolledwindow = gtk_scrolled_window_new(NULL, NULL);
  gtk_widget_show(scrolledwindow);
  // gtk_paned_pack1(GTK_PANED(main_hpaned), scrolledwindow6, TRUE, TRUE);
  gtk_box_pack_start((GtkBox *) vbox, scrolledwindow, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolledwindow),
                                 GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(scrolledwindow),
                                      GTK_SHADOW_IN);

  viewport = gtk_viewport_new(NULL, NULL);
  gtk_widget_show(viewport);
  gtk_container_add(GTK_CONTAINER(scrolledwindow), viewport);
  gtk_viewport_set_shadow_type(GTK_VIEWPORT(viewport), GTK_SHADOW_NONE);



  // QUANDO LA MADONNA E' BASTARDA, MA NOI CMQ LO SIAMO DI PIU' 

  fold_store =
    (GtkWidget *) gtk_tree_store_new(4, GDK_TYPE_PIXBUF, G_TYPE_STRING,
                                     G_TYPE_STRING, G_TYPE_POINTER);
  // LISTATO DEI FOLDERs


  fold_tree = gtk_tree_view_new();

  // g_signal_connect((gpointer) fold_tree, "drag_begin",
  // G_CALLBACK(on_fold_tree_drag_begin), NULL);


  gtk_tree_view_set_headers_visible(GTK_TREE_VIEW(fold_tree), FALSE);

  gtk_tree_view_set_model(GTK_TREE_VIEW(fold_tree),
                          GTK_TREE_MODEL(fold_store));


  fold_renderer = gtk_cell_renderer_pixbuf_new();
  fold_col =
    gtk_tree_view_column_new_with_attributes("What", fold_renderer, "pixbuf",
                                             FOLD_ICON, NULL);
  gtk_tree_view_append_column(GTK_TREE_VIEW(fold_tree), fold_col);
  gtk_tree_view_column_set_resizable(GTK_TREE_VIEW_COLUMN(fold_col), TRUE);
  // gtk_tree_view_column_set_max_width(GTK_TREE_VIEW_COLUMN(fold_col), 30);



  fold_renderer = gtk_cell_renderer_text_new();

  fold_col =
    gtk_tree_view_column_new_with_attributes("Folders", fold_renderer, "text",
                                             FOLD_NAME, NULL);
  gtk_tree_view_append_column(GTK_TREE_VIEW(fold_tree), fold_col);
  gtk_tree_view_column_set_resizable(GTK_TREE_VIEW_COLUMN(fold_col), TRUE);
  // gtk_tree_view_column_set_expand(GTK_TREE_VIEW_COLUMN(fold_col), TRUE);

  fold_col =
    gtk_tree_view_column_new_with_attributes("New/All", fold_renderer, "text",
                                             FOLD_NUM, NULL);
  gtk_tree_view_append_column(GTK_TREE_VIEW(fold_tree), fold_col);
  gtk_tree_view_column_set_resizable(GTK_TREE_VIEW_COLUMN(fold_col), TRUE);
  gtk_tree_view_column_set_expand(GTK_TREE_VIEW_COLUMN(fold_col), TRUE);

  gtk_widget_show(fold_tree);

  fold_box = gtk_vbox_new(FALSE, 0);
  gtk_widget_show(fold_box);

  gtk_container_add(GTK_CONTAINER(viewport), fold_box);
  gtk_container_add((GtkContainer *) fold_box, fold_tree);
  // gtk_tree_view_expand_row(GTK_TREE_VIEW(fold_tree),
  // gtk_tree_path_new_from_string("0"), FALSE);
  // gtk_tree_view_columns_autosize(GTK_TREE_VIEW(fold_tree));

  fold_sel = gtk_tree_view_get_selection(GTK_TREE_VIEW(fold_tree));
  gtk_tree_selection_select_iter(GTK_TREE_SELECTION(fold_sel), &fold_iter);



  if (nfolds)
    print_folders();

  mail_store = (GtkWidget *)
    gtk_list_store_new(MAIL_NCOL, GDK_TYPE_PIXBUF, G_TYPE_STRING,
                       GDK_TYPE_PIXBUF, G_TYPE_STRING, G_TYPE_STRING,
                       G_TYPE_POINTER, G_TYPE_BOOLEAN);
  if (nfolds > 0)
    print_mails(mail_store, folder[0], 0, NULL);



  // here there's plugins window

  more_expander = gtk_expander_new(NULL);
  gtk_widget_show(more_expander);
  gtk_box_pack_start(GTK_BOX(vbox), more_expander, FALSE, TRUE, 0);

  plugbox = NULL;
  plugin_main();

  label = gtk_label_new(_("More window"));
  gtk_widget_show(label);
  gtk_expander_set_label_widget(GTK_EXPANDER(more_expander), label);


  // end plugin window

  main_vpaned = gtk_vpaned_new();
  gtk_widget_show(main_vpaned);
  gtk_paned_pack2(GTK_PANED(main_hpaned), main_vpaned, TRUE, FALSE);
  gtk_paned_set_position(GTK_PANED(main_vpaned), 180);

  scrolledwindow5 = gtk_scrolled_window_new(NULL, NULL);
  gtk_widget_show(scrolledwindow5);
  gtk_paned_pack1(GTK_PANED(main_vpaned), scrolledwindow5, FALSE, TRUE);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolledwindow5),
                                 GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(scrolledwindow5),
                                      GTK_SHADOW_IN);


  mail_tree = gtk_tree_view_new();
  gtk_tree_view_set_model(GTK_TREE_VIEW(mail_tree),
                          GTK_TREE_MODEL(mail_store));
  gtk_tree_view_set_headers_clickable(GTK_TREE_VIEW(mail_tree), TRUE);


  gtk_widget_show(mail_tree);
  gtk_container_add(GTK_CONTAINER(scrolledwindow5), mail_tree);


  renderer = gtk_cell_renderer_pixbuf_new();

  mail_col =
    gtk_tree_view_column_new_with_attributes("", renderer, "pixbuf",
                                             MAIL_ATTACH, NULL);
  gtk_tree_view_append_column(GTK_TREE_VIEW(mail_tree), mail_col);
  gtk_tree_view_column_set_fixed_width(GTK_TREE_VIEW_COLUMN(mail_col), 17);


  renderer = gtk_cell_renderer_text_new();
  g_object_set(renderer, "size", 8000, "size-set", TRUE, NULL);

  mail_col =
    gtk_tree_view_column_new_with_attributes("Date", renderer, "text",
                                             MAIL_DATE, NULL);
  gtk_tree_view_column_set_cell_data_func(mail_col, renderer, mail_renderer,
                                          NULL, NULL);
  gtk_tree_view_append_column(GTK_TREE_VIEW(mail_tree), mail_col);
  gtk_tree_view_column_set_min_width(GTK_TREE_VIEW_COLUMN(mail_col), 35);
  gtk_tree_view_column_set_max_width(GTK_TREE_VIEW_COLUMN(mail_col), 35);
  gtk_tree_view_column_set_expand(GTK_TREE_VIEW_COLUMN(mail_col), TRUE);
  gtk_tree_view_column_set_resizable(GTK_TREE_VIEW_COLUMN(mail_col), TRUE);

  renderer = gtk_cell_renderer_pixbuf_new();

  mail_col =
    gtk_tree_view_column_new_with_attributes("", renderer, "pixbuf",
                                             MAIL_NEW, NULL);
  gtk_tree_view_append_column(GTK_TREE_VIEW(mail_tree), mail_col);
  gtk_tree_view_column_set_fixed_width(GTK_TREE_VIEW_COLUMN(mail_col), 2);
  gtk_tree_view_column_set_cell_data_func(mail_col, renderer, mail_renderer,
                                          NULL, NULL);

  renderer = gtk_cell_renderer_text_new();
  g_object_set(renderer, "size", 8000, "size-set", TRUE, NULL);

  mail_col =
    gtk_tree_view_column_new_with_attributes("From", renderer, "text",
                                             MAIL_FROM, NULL);
  gtk_tree_view_column_set_cell_data_func(mail_col, renderer, mail_renderer,
                                          NULL, NULL);
  gtk_tree_view_append_column(GTK_TREE_VIEW(mail_tree), mail_col);
  gtk_tree_view_column_set_fixed_width(GTK_TREE_VIEW_COLUMN(mail_col), 180);
  gtk_tree_view_column_set_expand(GTK_TREE_VIEW_COLUMN(mail_col), TRUE);
  gtk_tree_view_column_set_sizing(GTK_TREE_VIEW_COLUMN(mail_col),
                                  GTK_TREE_VIEW_COLUMN_FIXED);
  gtk_tree_view_column_set_resizable(GTK_TREE_VIEW_COLUMN(mail_col), TRUE);


  mail_col =
    gtk_tree_view_column_new_with_attributes("Subject", renderer, "text",
                                             MAIL_SUBJECT, NULL);
  gtk_tree_view_column_set_cell_data_func(mail_col, renderer, mail_renderer,
                                          NULL, NULL);
  gtk_tree_view_append_column(GTK_TREE_VIEW(mail_tree), mail_col);
  gtk_tree_view_column_set_min_width(GTK_TREE_VIEW_COLUMN(mail_col), 295);
  gtk_tree_view_column_set_expand(GTK_TREE_VIEW_COLUMN(mail_col), TRUE);
  gtk_tree_view_column_set_resizable(GTK_TREE_VIEW_COLUMN(mail_col), TRUE);
  gtk_tree_view_column_set_sizing(GTK_TREE_VIEW_COLUMN(mail_col),
                                  GTK_TREE_VIEW_COLUMN_FIXED);

  if (nfolds > 0)
    print_mails(mail_store, folder[0], 0, NULL);


  gtk_tree_model_get_iter_first(GTK_TREE_MODEL(mail_store), &mail_iter);
  mail_sel = gtk_tree_view_get_selection(GTK_TREE_VIEW(mail_tree));
  gtk_tree_selection_select_iter(GTK_TREE_SELECTION(mail_sel), &mail_iter);

  preview_vbox = gtk_vbox_new(FALSE, 0);
  gtk_widget_show(preview_vbox);
  gtk_paned_pack2(GTK_PANED(main_vpaned), preview_vbox, TRUE, TRUE);

  scrolledwindow = gtk_scrolled_window_new(NULL, NULL);
  gtk_widget_show(scrolledwindow);
  gtk_box_pack_start(GTK_BOX(preview_vbox), scrolledwindow, FALSE, TRUE, 0);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolledwindow),
                                 GTK_POLICY_NEVER, GTK_POLICY_NEVER);
  gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(scrolledwindow),
                                      GTK_SHADOW_NONE);


  preview_viewport = gtk_viewport_new(NULL, NULL);
  // gtk_widget_show (preview_viewport);

  gtk_container_add(GTK_CONTAINER(scrolledwindow), preview_viewport);
  gtk_viewport_set_shadow_type(GTK_VIEWPORT(preview_viewport),
                               GTK_SHADOW_ETCHED_IN);

  scrolledwindow4 = gtk_scrolled_window_new(NULL, NULL);
  gtk_widget_show(scrolledwindow4);
  gtk_box_pack_end(GTK_BOX(preview_vbox), scrolledwindow4, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolledwindow4),
                                 GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(scrolledwindow4),
                                      GTK_SHADOW_IN);

  selmail_textview = gtk_text_view_new();
  gtk_widget_show(selmail_textview);
  gtk_container_add(GTK_CONTAINER(scrolledwindow4), selmail_textview);
  gtk_text_view_set_editable(GTK_TEXT_VIEW(selmail_textview), FALSE);
  gtk_text_view_set_cursor_visible(GTK_TEXT_VIEW(selmail_textview), FALSE);
  // gtk_text_view_set_pixels_above_lines (GTK_TEXT_VIEW (selmail_textview),
  // 5);
  // gtk_text_view_set_pixels_below_lines (GTK_TEXT_VIEW (selmail_textview),
  // 5);
  gtk_text_view_set_left_margin(GTK_TEXT_VIEW(selmail_textview), 5);
  gtk_text_view_set_right_margin(GTK_TEXT_VIEW(selmail_textview), 5);

  selmail_buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(selmail_textview));


  if (nfolds > 0 && folder[0]->head && folder[0]->head->mail)
    print_mail_preview(head_table);



  main_menubar = create_menubar(NULL);
  gtk_widget_show(main_menubar);
  gtk_box_pack_start(GTK_BOX(mainmenubar_hbox), main_menubar, TRUE, TRUE, 0);

  toolbar1 = create_toolbar(NULL);
  gtk_box_pack_end(GTK_BOX(hbox), toolbar1, FALSE, FALSE, 0);



  maillist_menu = create_maillist_menu();
  foldlist_menu = create_foldlist_menu();



  hbox = gtk_hbox_new(FALSE, 2);
  gtk_widget_show(hbox);
  gtk_box_pack_start((GtkBox *) main_vbox, hbox, FALSE, FALSE, 0);

  main_statusbar = gtk_statusbar_new();
  gtk_widget_show(main_statusbar);
  gtk_box_pack_start(GTK_BOX(hbox), main_statusbar, TRUE, TRUE, 0);

  // respect
  // 
  // ...si ho sclerato due ore prima di accorgemi che catchavi le mail
  // prima che esistessero 8D
  if (1)
  {
    static GtkTargetEntry target[] = {
      // {"STRING", 0, 0},
      // {"txt/plain", 0, 1},
      {"GTK_TREE_MODEL_ROW", 0, 2}
    };

    gtk_tree_view_enable_model_drag_dest((GtkTreeView *) mail_tree, target, 2,
                                         GDK_ACTION_COPY | GDK_ACTION_MOVE |
                                         GDK_ACTION_LINK);

    gtk_tree_view_enable_model_drag_dest((GtkTreeView *) fold_tree, target, 2,
                                         GDK_ACTION_COPY | GDK_ACTION_MOVE |
                                         GDK_ACTION_LINK);
    gtk_tree_view_enable_model_drag_source((GtkTreeView *) mail_tree,
                                           GDK_BUTTON1_MASK |
                                           GDK_BUTTON3_MASK, target, 2,
                                           GDK_ACTION_COPY | GDK_ACTION_MOVE |
                                           GDK_ACTION_LINK);
    gtk_tree_view_enable_model_drag_source((GtkTreeView *) fold_tree,
                                           GDK_BUTTON1_MASK |
                                           GDK_BUTTON3_MASK, target, 2,
                                           GDK_ACTION_COPY | GDK_ACTION_MOVE |
                                           GDK_ACTION_LINK);

  }
  // progressbar = gtk_progress_bar_new();
  // gtk_widget_show(progressbar);
  // gtk_box_pack_end(GTK_BOX(hbox), progressbar, FALSE, FALSE, 0);


  // g_signal_connect(mail_tree, "drag_data_received",
  // G_CALLBACK(on_foldtree_dnd_receive), NULL);

  g_signal_connect(fold_tree, "drag_data_received",
                   G_CALLBACK(on_foldtree_dnd_receive), NULL);

  g_signal_connect((gpointer) mail_sel, "changed",
                   G_CALLBACK(print_mail_preview), NULL);


  g_signal_connect((gpointer) fold_sel, "changed",
                   G_CALLBACK(on_fold_changed), NULL);


  g_signal_connect((gpointer) mail_tree, "button_press_event",
                   G_CALLBACK(event_press_on_mail_list),
                   (gpointer) maillist_menu);

  g_signal_connect((gpointer) fold_tree, "button_press_event",
                   G_CALLBACK(event_press_on_fold_list),
                   (gpointer) foldlist_menu);

  g_signal_connect((gpointer) mail_tree, "row_activated",
                   G_CALLBACK(on_open_mail_activate), 0);

  g_signal_connect((gpointer) main_window, "destroy_event",
                   G_CALLBACK(on_mainquit_button_clicked), NULL);


  /*
   * g_signal_connect((gpointer) mainquit_button, "clicked",
   * G_CALLBACK(on_mainquit_button_clicked), NULL);
   */




  gtk_widget_grab_focus(main_menubar);
  gtk_widget_grab_default(main_menubar);
  return main_window;
}


GtkWidget *
create_mail_filechooserdialog(void)
{

  GtkWidget *mail_dialog_vbox;
  GtkWidget *button_dialog_action_area;
  GtkWidget *cancel_button;
  GtkWidget *open_button;

  mail_filechooserdialog =
    gtk_file_chooser_dialog_new(_(":: mail from file ::"), NULL,
                                GTK_FILE_CHOOSER_ACTION_OPEN, NULL);
  gtk_window_set_type_hint(GTK_WINDOW(mail_filechooserdialog),
                           GDK_WINDOW_TYPE_HINT_DIALOG);

  mail_dialog_vbox = GTK_DIALOG(mail_filechooserdialog)->vbox;
  gtk_widget_show(mail_dialog_vbox);

  button_dialog_action_area = GTK_DIALOG(mail_filechooserdialog)->action_area;
  gtk_widget_show(button_dialog_action_area);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(button_dialog_action_area),
                            GTK_BUTTONBOX_END);

  cancel_button = gtk_button_new_from_stock("gtk-cancel");
  gtk_widget_show(cancel_button);
  gtk_dialog_add_action_widget(GTK_DIALOG(mail_filechooserdialog),
                               cancel_button, GTK_RESPONSE_CANCEL);
  GTK_WIDGET_SET_FLAGS(cancel_button, GTK_CAN_DEFAULT);

  open_button = gtk_button_new_from_stock("gtk-open");
  gtk_widget_show(open_button);
  gtk_dialog_add_action_widget(GTK_DIALOG(mail_filechooserdialog),
                               open_button, GTK_RESPONSE_OK);
  GTK_WIDGET_SET_FLAGS(open_button, GTK_CAN_DEFAULT);

  g_signal_connect((gpointer) cancel_button, "clicked",
                   G_CALLBACK(on_from_file_cancel_clicked), NULL);
  g_signal_connect((gpointer) open_button, "clicked",
                   G_CALLBACK(on_from_file_open_clicked), NULL);

  gtk_widget_grab_default(open_button);
  return mail_filechooserdialog;
}



GtkWidget *
create_button(GtkWidget * toolbar, const char *tooltip, const char *icon)
{
  GtkWidget *button, *img;
  GtkToolItem *toolitem = gtk_tool_item_new();
  GtkTooltips *tooltips = gtk_tooltips_new();
  char path[300];


  gtk_widget_show(GTK_WIDGET(toolitem));
  gtk_tool_item_set_homogeneous(GTK_TOOL_ITEM(toolitem), TRUE);
  gtk_container_add(GTK_CONTAINER(toolbar), GTK_WIDGET(toolitem));


  button = gtk_button_new();
  gtk_button_set_relief(GTK_BUTTON(button), GTK_RELIEF_NONE);
  gtk_widget_show(button);
  gtk_container_add(GTK_CONTAINER(toolitem), button);
  gtk_tooltips_set_tip(tooltips, button, tooltip, NULL);

  snprintf(path, 299, "%s/Themes/%s/%s", MAILDIR, THEME, icon);
  img = gtk_image_new_from_file(path);
  gtk_widget_show(img);
  gtk_container_add(GTK_CONTAINER(button), img);
  return button;
}

void
make_separator(GtkWidget * toolbar)
{
  GtkWidget *toolbar_separator;

  toolbar_separator = (GtkWidget *) gtk_separator_tool_item_new();
  gtk_widget_show(toolbar_separator);
  gtk_tool_item_set_homogeneous(GTK_TOOL_ITEM(toolbar_separator), TRUE);
  gtk_container_add(GTK_CONTAINER(toolbar), toolbar_separator);
}

GtkWidget *
create_toolbar(struct email *cur_mail)
{
  GtkWidget *toolbar;
  GtkWidget *getmail_button;
  GtkWidget *compose_button;
  GtkWidget *contacts_button;
  GtkWidget *reply_button;
  GtkWidget *replyall_button;
  GtkWidget *forward_button;
  GtkWidget *del_button;
  GtkWidget *help_button;



  // create right toolbar
  toolbar = gtk_toolbar_new();
  gtk_widget_show(toolbar);
  gtk_toolbar_set_style(GTK_TOOLBAR(toolbar), GTK_TOOLBAR_BOTH);
  gtk_widget_set_size_request(toolbar, 80, -1);
  gtk_toolbar_set_orientation(GTK_TOOLBAR(toolbar), GTK_ORIENTATION_VERTICAL);


  // Get mail button
  getmail_button = create_button(toolbar, "Download emails", "getmail.png");
  g_signal_connect(getmail_button, "clicked",
                   G_CALLBACK(on_get_mail_activate), NULL);

  compose_button = create_button(toolbar, "Compose", "compose.png");

  contacts_button = create_button(toolbar, "Address Book", "contact.png");

  make_separator(toolbar);

  reply_button = create_button(toolbar, "Reply", "reply.png");

  replyall_button = create_button(toolbar, "Reply All", "replyall.png");

  forward_button = create_button(toolbar, "Forward", "forward.png");

  del_button = create_button(toolbar, "Delete", "delete.png");

  help_button = create_button(toolbar, "Help", "help.png");

  make_separator(toolbar);

  g_signal_connect((gpointer) compose_button, "clicked",
                   G_CALLBACK(on_new_mail_activate), NULL);
  g_signal_connect((gpointer) contacts_button, "clicked",
                   G_CALLBACK(on_contacts_activate), NULL);
  g_signal_connect((gpointer) reply_button, "clicked",
                   G_CALLBACK(on_reply_button_clicked), (gpointer) cur_mail);

  g_signal_connect((gpointer) replyall_button, "clicked",
                   G_CALLBACK(on_replyall_button_clicked),
                   (gpointer) cur_mail);
  g_signal_connect((gpointer) forward_button, "clicked",
                   G_CALLBACK(on_forward_button_clicked),
                   (gpointer) cur_mail);
  g_signal_connect((gpointer) del_button, "clicked",
                   G_CALLBACK(on_del_button_clicked), NULL);

  g_signal_connect((gpointer) getmail_button, "enter",
                   G_CALLBACK(on_get_mail_enter), NULL);

  return toolbar;
}


GtkWidget *
create_maillist_menu(void)
{
  // GtkWidget *maillist_menu;
  GtkWidget *open_mail;
  GtkWidget *reply;
  GtkWidget *reply_all;
  GtkWidget *forward;
  GtkWidget *move_to;
  GtkWidget *move_to_menu;
  GtkWidget *copy_to;
  GtkWidget *copy_to_menu;
  GtkWidget *child, *sep, *edit_as_new, *del_mail, *sel_all;
  int i;

  maillist_menu = gtk_menu_new();

  open_mail = gtk_menu_item_new_with_mnemonic(_("   Open e-mail    "));
  gtk_widget_show(open_mail);
  gtk_container_add(GTK_CONTAINER(maillist_menu), open_mail);


  sep = gtk_separator_menu_item_new();
  gtk_widget_show(sep);
  gtk_container_add(GTK_CONTAINER(maillist_menu), sep);

  reply = gtk_menu_item_new_with_mnemonic(_("   Reply   "));
  gtk_widget_show(reply);
  gtk_container_add(GTK_CONTAINER(maillist_menu), reply);

  reply_all = gtk_menu_item_new_with_mnemonic(_("   Reply all   "));
  gtk_widget_show(reply_all);
  gtk_container_add(GTK_CONTAINER(maillist_menu), reply_all);

  forward = gtk_menu_item_new_with_mnemonic(_("   Forward   "));
  gtk_widget_show(forward);
  gtk_container_add(GTK_CONTAINER(maillist_menu), forward);

  edit_as_new = gtk_menu_item_new_with_mnemonic(_("   Edit mail as new   "));
  gtk_widget_show(edit_as_new);
  gtk_container_add(GTK_CONTAINER(maillist_menu), edit_as_new);

  sep = gtk_separator_menu_item_new();
  gtk_widget_show(sep);
  gtk_container_add(GTK_CONTAINER(maillist_menu), sep);

  sel_all = gtk_menu_item_new_with_mnemonic(_("   Select mail   "));
  gtk_widget_show(sel_all);
  gtk_container_add(GTK_CONTAINER(maillist_menu), sel_all);

  del_mail = gtk_menu_item_new_with_mnemonic(_("   Delete mail   "));
  gtk_widget_show(del_mail);
  gtk_container_add(GTK_CONTAINER(maillist_menu), del_mail);

  sep = gtk_separator_menu_item_new();
  gtk_widget_show(sep);
  gtk_container_add(GTK_CONTAINER(maillist_menu), sep);

  move_to = gtk_menu_item_new_with_mnemonic(_("   Move to   "));
  gtk_widget_show(move_to);
  gtk_container_add(GTK_CONTAINER(maillist_menu), move_to);

  move_to_menu = gtk_menu_new();
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(move_to), move_to_menu);

  copy_to = gtk_menu_item_new_with_mnemonic(_("   Copy to   "));
  gtk_widget_show(copy_to);
  gtk_container_add(GTK_CONTAINER(maillist_menu), copy_to);

  copy_to_menu = gtk_menu_new();
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(copy_to), copy_to_menu);

  for (i = nfolds - 1; i >= 0; i--)
  {
    child = gtk_menu_item_new_with_mnemonic(_(folder[i]->name));
    gtk_widget_show(child);
    gtk_container_add(GTK_CONTAINER(move_to_menu), child);
    g_signal_connect((gpointer) child, "activate",
                     G_CALLBACK(on_moveto_activate), folder[i]->name);

    child = gtk_menu_item_new_with_mnemonic(_(folder[i]->name));
    gtk_widget_show(child);
    gtk_container_add(GTK_CONTAINER(copy_to_menu), child);
    // g_signal_connect((gpointer) forward, "clicked",
    // G_CALLBACK(on_copyto_clicked), (gpointer)folder[i]->name);
  }

  g_signal_connect((gpointer) reply, "activate",
                   G_CALLBACK(on_reply_button_clicked), NULL);

  g_signal_connect((gpointer) forward, "activate",
                   G_CALLBACK(on_forward_button_clicked), NULL);

  g_signal_connect((gpointer) edit_as_new, "activate",
                   G_CALLBACK(on_edit_as_new_activate), NULL);


  return maillist_menu;
}

GtkWidget *
create_foldlist_menu(void)
{
  // GtkWidget *foldlist_menu;
  GtkWidget *new_folder, *del_folder, *rename_folder, *mark_as_read, *export,
    *sep;

  foldlist_menu = gtk_menu_new();

  mark_as_read = gtk_menu_item_new_with_mnemonic(_("   Mark as read    "));
  gtk_widget_show(mark_as_read);
  gtk_container_add(GTK_CONTAINER(foldlist_menu), mark_as_read);

  sep = gtk_separator_menu_item_new();
  gtk_widget_show(sep);
  gtk_container_add(GTK_CONTAINER(foldlist_menu), sep);

  new_folder = gtk_menu_item_new_with_mnemonic(_("   New folder    "));
  gtk_widget_show(new_folder);
  gtk_container_add(GTK_CONTAINER(foldlist_menu), new_folder);


  rename_folder = gtk_menu_item_new_with_mnemonic(_("   Rename folder   "));
  gtk_widget_show(rename_folder);
  gtk_container_add(GTK_CONTAINER(foldlist_menu), rename_folder);

  del_folder = gtk_menu_item_new_with_mnemonic(_("   Delete folder  "));
  gtk_widget_show(del_folder);
  gtk_container_add(GTK_CONTAINER(foldlist_menu), del_folder);

  sep = gtk_separator_menu_item_new();
  gtk_widget_show(sep);
  gtk_container_add(GTK_CONTAINER(foldlist_menu), sep);

  export = gtk_menu_item_new_with_mnemonic(_("   Export folder  "));
  gtk_widget_show(export);
  gtk_container_add(GTK_CONTAINER(foldlist_menu), export);

  g_signal_connect((gpointer) del_folder, "activate",
                   G_CALLBACK(on_delete_folder_activate), NULL);

  g_signal_connect((gpointer) new_folder, "activate",
                   G_CALLBACK(on_new_folder_activate), NULL);

  return foldlist_menu;
}

GtkWidget *
create_mailaddress_menu(struct email * mail)
{
  struct contacts_group *p;
  GtkWidget *mailadd_menu;
  GtkWidget *write, *add_to_contacts, *child, *label;



  mailadd_menu = gtk_menu_new();

  label = gtk_label_new(_("   Address menu   "));
  gtk_widget_show(label);
  gtk_container_add(GTK_CONTAINER(mailadd_menu), label);

  label = gtk_separator_menu_item_new();
  gtk_widget_show(label);
  gtk_container_add(GTK_CONTAINER(foldlist_menu), label);

  write = gtk_menu_item_new_with_mnemonic(_("   Compose   "));
  gtk_widget_show(write);
  gtk_container_add(GTK_CONTAINER(mailadd_menu), write);

  add_to_contacts =
    gtk_menu_item_new_with_mnemonic(_("   Add contact in    "));
  gtk_widget_show(add_to_contacts);
  gtk_container_add(GTK_CONTAINER(mailadd_menu), add_to_contacts);

  label = gtk_menu_new();
  gtk_widget_show(label);
  gtk_menu_item_set_submenu((GtkMenuItem *) add_to_contacts, label);

  p = groups;
  while (p)
  {
    printf("groups %s.\n", p->name);
    child = gtk_menu_item_new_with_mnemonic(_(p->name));
    gtk_widget_show(child);
    gtk_container_add(GTK_CONTAINER(label), child);
    // g_signal_connect((gpointer) forward, "clicked",
    // G_CALLBACK(on_moveto_clicked), NULL);
    p = p->next;
  }

  g_signal_connect((gpointer) write, "activate",
                   G_CALLBACK(on_compose_activate), mail);

  /*
   * g_signal_connect((gpointer) new_folder, "activate",
   * G_CALLBACK(on_new_folder_activate), NULL);
   */

  return mailadd_menu;
}


GtkWidget *
create_utility_bar()
{
  GtkWidget *scrolledwindow, *label, *viewport, *hbox;
  GtkWidget *out_scrolledwindow, *out_hbox, *view_hbox, *search_hbox;

  GtkWidget *searchstr;
  GtkWidget *searchbox;

  out_scrolledwindow = gtk_scrolled_window_new(NULL, NULL);
  gtk_widget_set_size_request(out_scrolledwindow, -1, 30);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(out_scrolledwindow),
                                 GTK_POLICY_NEVER, GTK_POLICY_NEVER);

  viewport = gtk_viewport_new(NULL, NULL);
  gtk_widget_show(viewport);
  gtk_container_add(GTK_CONTAINER(out_scrolledwindow), viewport);
  gtk_viewport_set_shadow_type(GTK_VIEWPORT(viewport), GTK_SHADOW_OUT);

  out_hbox = gtk_hbox_new(FALSE, 0);
  gtk_widget_show(out_hbox);
  gtk_container_add(GTK_CONTAINER(viewport), out_hbox);

  hbox = gtk_hbox_new(TRUE, 0);
  gtk_widget_show(hbox);
  gtk_box_pack_start(GTK_BOX(out_hbox), hbox, FALSE, FALSE, 0);
  gtk_widget_set_size_request(hbox, 178, -1);

  scrolledwindow = gtk_scrolled_window_new(NULL, NULL);
  gtk_widget_show(scrolledwindow);
  gtk_box_pack_start(GTK_BOX(hbox), scrolledwindow, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolledwindow),
                                 GTK_POLICY_NEVER, GTK_POLICY_NEVER);

  viewport = gtk_viewport_new(NULL, NULL);
  gtk_widget_show(viewport);
  gtk_container_add(GTK_CONTAINER(scrolledwindow), viewport);
  gtk_viewport_set_shadow_type(GTK_VIEWPORT(viewport), GTK_SHADOW_ETCHED_IN);

  total_label = gtk_label_new(_(""));
  gtk_widget_show(total_label);
  gtk_container_add(GTK_CONTAINER(viewport), total_label);


  scrolledwindow = gtk_scrolled_window_new(NULL, NULL);
  gtk_widget_show(scrolledwindow);
  gtk_box_pack_start(GTK_BOX(hbox), scrolledwindow, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolledwindow),
                                 GTK_POLICY_NEVER, GTK_POLICY_NEVER);

  viewport = gtk_viewport_new(NULL, NULL);
  gtk_widget_show(viewport);
  gtk_container_add(GTK_CONTAINER(scrolledwindow), viewport);
  gtk_viewport_set_shadow_type(GTK_VIEWPORT(viewport), GTK_SHADOW_ETCHED_IN);

  unread_label = gtk_label_new(_(""));
  gtk_widget_show(unread_label);
  gtk_container_add(GTK_CONTAINER(viewport), unread_label);

  view_hbox = gtk_hbox_new(FALSE, 0);
  gtk_widget_show(view_hbox);
  gtk_box_pack_start(GTK_BOX(out_hbox), view_hbox, TRUE, TRUE, 40);

  label = gtk_label_new(_("View :: "));
  gtk_widget_show(label);
  gtk_box_pack_start(GTK_BOX(view_hbox), label, FALSE, FALSE, 0);

  view_combobox = gtk_combo_box_new_text();
  gtk_widget_show(view_combobox);
  gtk_box_pack_start(GTK_BOX(view_hbox), view_combobox, FALSE, TRUE, 0);
  gtk_widget_set_size_request(view_combobox, 120, -1);
  gtk_combo_box_append_text(GTK_COMBO_BOX(view_combobox), _("All mails"));
  gtk_combo_box_append_text(GTK_COMBO_BOX(view_combobox), _("New mails"));
  gtk_combo_box_append_text(GTK_COMBO_BOX(view_combobox), _("Important"));
  gtk_combo_box_set_active(GTK_COMBO_BOX(view_combobox), 0);

  search_hbox = gtk_hbox_new(FALSE, 0);
  gtk_widget_show(search_hbox);
  gtk_box_pack_end(GTK_BOX(out_hbox), search_hbox, TRUE, TRUE, 0);

  searchbox = gtk_combo_box_new_text();

  gtk_combo_box_append_text(GTK_COMBO_BOX(searchbox), "Subject");
  gtk_combo_box_append_text(GTK_COMBO_BOX(searchbox), "From");
  gtk_combo_box_append_text(GTK_COMBO_BOX(searchbox), "Body");
  gtk_combo_box_set_active(GTK_COMBO_BOX(searchbox), 0);
  gtk_widget_show(searchbox);

  gtk_box_pack_end(GTK_BOX(search_hbox), searchbox, FALSE, FALSE, 0);

  searchstr = gtk_entry_new();
  gtk_widget_show(searchstr);
  gtk_box_pack_end(GTK_BOX(search_hbox), searchstr, FALSE, FALSE, 0);



  label = gtk_label_new(_("Search :: "));
  gtk_widget_show(label);
  gtk_box_pack_end(GTK_BOX(search_hbox), label, FALSE, FALSE, 0);
  gtk_label_set_use_markup(GTK_LABEL(label), TRUE);

  g_signal_connect((gpointer) view_combobox, "changed",
                   G_CALLBACK(on_view_changed), NULL);


  g_signal_connect((gpointer) searchstr, "changed",
                   G_CALLBACK(on_search_change), (gpointer) searchbox);


  return out_scrolledwindow;
}


GtkWidget *
create_alert_dialog(char *alert)
{
  GtkWidget *alert_dialog;
  GtkWidget *dialog_vbox;
  GtkWidget *hbox;
  GtkWidget *image;
  GtkWidget *label;
  GtkWidget *dialog_action_area;
  GtkWidget *okbutton;

  alert_dialog = gtk_dialog_new();
  gtk_window_set_title(GTK_WINDOW(alert_dialog), _("-= alert =-"));
  gtk_window_set_position(GTK_WINDOW(alert_dialog), GTK_WIN_POS_CENTER);
  gtk_window_set_type_hint(GTK_WINDOW(alert_dialog),
                           GDK_WINDOW_TYPE_HINT_DIALOG);

  dialog_vbox = GTK_DIALOG(alert_dialog)->vbox;
  gtk_widget_show(dialog_vbox);

  hbox = gtk_hbox_new(FALSE, 0);
  gtk_widget_show(hbox);
  gtk_box_pack_start(GTK_BOX(dialog_vbox), hbox, TRUE, FALSE, 15);

  image = gtk_image_new_from_stock("gtk-dialog-warning", GTK_ICON_SIZE_DND);
  gtk_widget_show(image);
  gtk_box_pack_start(GTK_BOX(hbox), image, FALSE, FALSE, 20);

  label = gtk_label_new(_(alert));
  gtk_widget_show(label);
  gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 20);

  dialog_action_area = GTK_DIALOG(alert_dialog)->action_area;
  gtk_widget_show(dialog_action_area);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(dialog_action_area),
                            GTK_BUTTONBOX_END);

  okbutton = gtk_button_new_with_label(_("Ok"));
  gtk_widget_show(okbutton);
  gtk_dialog_add_action_widget(GTK_DIALOG(alert_dialog), okbutton,
                               GTK_RESPONSE_OK);
  GTK_WIDGET_SET_FLAGS(okbutton, GTK_CAN_DEFAULT);

  g_signal_connect((gpointer) okbutton, "clicked",
                   G_CALLBACK(on_okalert_button_clicked),
                   (gpointer) alert_dialog);

  return alert_dialog;
}

GtkWidget *
create_fast_contacts()
{
  GtkWidget *tree;
  GtkTreeStore *store;
  GtkTreeViewColumn *col;
  GtkCellRenderer *rend;
  GtkTreeIter cont, parent;
  struct contacts_group *g;
  struct contacts *c;

  enum
  {
    TEXT,
    POINTER,
    FLAG,
    NCOL
  };

  store = gtk_tree_store_new(NCOL, G_TYPE_STRING, G_TYPE_POINTER, G_TYPE_INT);
  g = groups;


  while (g)
  {
    c = g->head;
    gtk_tree_store_append(store, &parent, NULL);
    gtk_tree_store_set(store, &parent, TEXT, g->name, POINTER, (gpointer) g,
                       FLAG, 0, -1);
    while (c)
    {
      gtk_tree_store_append(store, &cont, &parent);
      gtk_tree_store_set(store, &cont, TEXT, c->name, POINTER, (gpointer) c,
                         FLAG, 1, -1);
      c = c->next;
    }
    g = g->next;
  }


  tree = gtk_tree_view_new_with_model((GtkTreeModel *) store);
  gtk_tree_view_set_headers_visible(GTK_TREE_VIEW(tree), FALSE);

  rend = gtk_cell_renderer_text_new();
  col = gtk_tree_view_column_new_with_attributes("Who", rend, "text",
                                                 0, NULL);
  gtk_tree_view_append_column(GTK_TREE_VIEW(tree), col);
  gtk_tree_view_column_set_resizable(GTK_TREE_VIEW_COLUMN(col), TRUE);

  return tree;
}
