#include "../include.h"


void
on_foldtree_dnd_receive(GtkWidget * wgt, GdkDragContext * context, int x,
                        int y, GtkSelectionData * seldata, guint info,
                        guint time, gpointer userdata)
{



  printf("ma niente evento??\n");
  printf("cucu x = %d , y = %d data = %s\n", x, y, seldata->data);
  fflush(stdout);
}


void
on_delete_folder_activate(GtkWidget * widget, gpointer user_data)
{
  printf("premo sul delete\n");
}

gboolean
on_focus(GtkWidget * widget, GdkEvent * e, gpointer user_data)
{
  gtk_widget_hide(widget);
  gtk_widget_hide_all((GtkWidget *) user_data);
  return FALSE;
}

void
on_edit_done(GtkWidget * widget, gpointer user_data)
{
  const gchar *p = gtk_entry_get_text((GtkEntry *) widget);

  if (*p)
    new_folder(p);
  gtk_widget_hide(widget);
  gtk_widget_hide((GtkWidget *) user_data);
}

void
on_new_folder_activate(GtkWidget * widget, gpointer user_data)
{
  GtkWidget *entry, *label;

  entry = gtk_entry_new();
  label = gtk_label_new(_("Insert name of the folder: "));
  gtk_widget_show(label);
  gtk_widget_show(entry);

  gtk_box_pack_end((GtkBox *) fold_box, entry, FALSE, FALSE, 0);
  gtk_box_pack_end((GtkBox *) fold_box, label, FALSE, FALSE, 0);


  gtk_widget_grab_focus(entry);

  g_signal_connect((gpointer) entry, "activate",
                   G_CALLBACK(on_edit_done), label);

  g_signal_connect((gpointer) entry, "focus_out_event",
                   G_CALLBACK(on_focus), label);

}

list *drag_started = NULL;

void
on_fold_tree_drag_begin(GtkWidget * w, GdkDragContext * context,
                        GtkSelectionData * selectiondata, guint info,
                        guint time, gpointer dummy)
{
  GList *list;
  GtkTreeModel *model;
  GtkTreeIter iter;
  GtkTreeSelection *selection;

  selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(fold_tree));
  list = gtk_tree_selection_get_selected_rows(selection, &model);
  if (!list)
  {
    drag_started = NULL;
    return;
  }

  gtk_tree_model_get_iter(GTK_TREE_MODEL(model), &iter, list->data);
  gtk_tree_model_get(GTK_TREE_MODEL(model), &iter, MAIL_FROM, &drag_started,
                     -1);
  gtk_tree_path_free(list->data);

  g_list_free(list);

}
