/*
 * Copyright (C) 2003  
 * paranoy project - paranox.sf.net - paranoy@autistici.org
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */

#include "include.h"

void
setting()
{
  char *menu[8][19] = {
    {"General options", "Accounts", "Contacts", "Filters", "PGP",
     "Security", "Anonimity", 0},
    {"Mail check time", "* Change password",
     "Smtp server",
     "* Change paranoy's dir",
     "* Add signature to signature list", "Optimize remote use",
     "* Puts random signature at bottom", "Simple mode", "Set color",
     0},
    {"New account", "* Manage account(s)", 0},
    {"New contact", "Manage contact(s)", 0},
    {"New filter", "* Show my filter(s)", "* Delete filter", "* Edit filter",
     "* Add no-spam specification", 0},
    {"Generate new pair of key",
     "* Generate a revocation certificate", "* Set default keyserver",
     "* Search for a public key", "* Always put key fingerprint in email", 0},
    {"* Refresh anonymous remailer list && public keys",
     "* Sign always (no in anonymous mode)",
     "* Control paranoy's size", "* Encrypt if I have public key", 0},
    {"* Create new nymserver account", "* Set latency time",
     "* Deform mail size", 0}
  };

  byte change = 0;
  ushort mpos, lpos, dpos, where, i, ompos, olpos, owhere;
  int c;

  where = mpos = lpos = dpos = i = 0;
  owhere = ompos = olpos = 0;
  title("Settings");


  // make windows
  if (wmenu == NULL)
  {
    wmenu = newwin((int) LINES / 2 + 1, (int) COLS / 3, 1, 0);
    wlist =
      newwin((int) LINES / 2 + 1, (int) COLS * (2 / 3), 1, COLS / 3 - 1);
    wdata = newwin((int) LINES / 2 - 3, COLS, (int) LINES / 2 + 2, 0);
    scrollok(wdata, TRUE);
    keypad(wdata, TRUE);
    keypad(wmenu, TRUE);
    keypad(wlist, TRUE);
    keypad(winfo, TRUE);
  }
  wattrset(wmenu, A_NORMAL);
  wattrset(wlist, A_NORMAL);

  // draw box
  wborder(wmenu, 0, 0, 0, 0, 0, ACS_TTEE, 0, ACS_BTEE);
  wborder(wlist, 0, 0, 0, 0, ACS_TTEE, 0, ACS_BTEE, 0);

  // print the menu for the first time
  if (net_optimize)
    mvwprintw(wmenu, 3, 2, ">%s", menu[0][0]);
  else
  {
    wattron(wmenu, A_REVERSE);
    mvwprintw(wmenu, 3, 3, menu[0][0]);
    wattroff(wmenu, A_REVERSE);
  }

  for (i = 1; menu[0][i]; i++)
    mvwprintw(wmenu, i + 2, 3, menu[0][i]);

  // print the second menu
  if (!net_optimize)
    for (i = 0; menu[mpos + 1][i] != 0; i++)
      mvwprintw(wlist, i + 2, 3, menu[mpos + 1][i]);

  while (mpos != 100)           // <-si verfica se premo left nel menu
    // principale
  {
    // se siamo nel primo menu
    if (where == 0)
    {
      if (net_optimize)
      {
        if (where == owhere)
          mvwprintw(wmenu, ompos +2, 2, " ");
        else
        {
          mvwprintw(wlist, olpos + 2, 2, " ");
          owhere = where;
        }
        mvwprintw(wmenu, mpos + 2, 2, ">");
      } else
      {
        // arriviamo dallo stesso menu
        if (where == owhere)
        {
          clear_w(wlist, 1);
          // stampa il secondo menu
          for (i = 0; menu[mpos + 1][i] != 0; i++)
            mvwprintw(wlist, i + 2, 3, menu[mpos + 1][i]);

          wattrset(wmenu, A_NORMAL);
          mvwprintw(wmenu, ompos + 2, 3, menu[0][ompos]);

        } else
          // arriviamo dall'altro menu
        {
          wattrset(wlist, A_NORMAL);
          mvwprintw(wlist, olpos + 2, 3, menu[ompos + 1][olpos]);
          owhere = where;
        }
        wattrset(wmenu, A_REVERSE);
        mvwprintw(wmenu, mpos + 2, 3, menu[0][mpos]);
      }
    } else
      // siamo nel secondo menu
    {
      if (net_optimize)
      {
        if (where == owhere)
          mvwprintw(wlist, olpos + 2, 2, " ");
        else
        {
          owhere = where;
          mvwprintw(wmenu, ompos + 2, 2, " ");
          clear_w(wlist, 1);
          for (i = 0; menu[mpos + 1][i] != 0; i++)
            mvwprintw(wlist, i + 2, 3, menu[mpos + 1][i]);
        }
        mvwprintw(wlist, lpos + 2, 2, ">");
      } else
      {
        // arriviamo dallo stesso menu
        if (where == owhere)
        {
          wattrset(wlist, A_NORMAL);
          mvwprintw(wlist, olpos + 2, 3, menu[ompos + 1][olpos]);
        } else
          // arriviamo dall'altro menu
        {
          wattrset(wmenu, A_NORMAL);
          mvwprintw(wmenu, ompos + 2, 3, menu[0][ompos]);
          owhere = where;
        }
        wattrset(wlist, A_REVERSE);
        mvwprintw(wlist, lpos + 2, 3, menu[mpos + 1][lpos]);
      }
    }
    wrefresh(wmenu);
    wrefresh(wlist);
    c = getch();
    // gestisce l'interazione con l'utente
    switch (c)
    {
      case 'h':
      case '?':
      case KEY_F(1):

        if (where == 0)
          help("setting");
        else
          help(menu[0][mpos]);

        wattrset(wmenu, A_NORMAL);
        // draw i box
        wborder(wmenu, 0, 0, 0, 0, 0, ACS_TTEE, 0, ACS_BTEE);
        wborder(wlist, 0, 0, 0, 0, ACS_TTEE, 0, ACS_BTEE, 0);

        // stampa il primo menu
        for (i = 0; menu[0][i]; i++)
          mvwprintw(wmenu, i + 2, 3, menu[0][i]);

        // stampa il secondo menu
        if (!net_optimize)
          for (i = 0; menu[mpos + 1][i]; i++)
            mvwprintw(wlist, i + 2, 3, menu[mpos + 1][i]);

        // seleziona la roba precedente
        if (where == 0)
        {
          if (!net_optimize)
          {
            wattron(wmenu, A_REVERSE);
            mvwprintw(wmenu, mpos + 2, 3, menu[0][mpos]);
            wattroff(wmenu, A_REVERSE);
          } else
            mvwprintw(wmenu, mpos + 2, 2, ">");
        } else
        {
          if (!net_optimize)
          {
            wattron(wlist, A_REVERSE);
            mvwprintw(wlist, lpos + 2, 3, menu[mpos + 1][lpos]);
            wattroff(wlist, A_REVERSE);
          } else
            mvwprintw(wlist, lpos + 2, 2, ">");
        }

        break;

        // esce
      case 27:
      case 'q':
        mpos = 100;
        break;

        // tab (devo cambiare finestra)
      case 9:
        owhere = where;
        // la selezione e' sul menu principale
        if (where == 0)
        {
          owhere = where;
          where++;
          ompos = mpos;
          olpos = lpos = 0;
        }
        // la selezione e' sul menu secondario
        else
        {
          owhere = where;
          olpos = lpos;
          lpos = where = 0;

        }
        break;

      case KEY_UP:
        // siamo nel menu principale
        if (where == 0)
        {
          // se nn siamo alla prima voce
          if (mpos != 0)
          {
            ompos = mpos;
            mpos--;
          } else
            // siamo alla prima voce
          {
            ompos = mpos;
            mpos = 6;
          }
        }
        // siamo nel menu secondario
        else
        {
          // se nn siamo alla prima voce
          if (lpos != 0)
          {
            olpos = lpos;
            lpos--;
          } else
          {
            olpos = lpos;
            for (i = 0; menu[mpos + 1][i] != 0; i++);
            lpos = i - 1;
          }
        }
        break;

      case KEY_DOWN:
        // siamo nel menu principale
        if (where == 0)
        {
          // se nn siamo in ultima posizione 
          if (mpos != 6)
          {
            ompos = mpos;
            mpos++;
          } else
            // siamo iin ultima posizione
          {
            ompos = mpos;
            mpos = 0;
          }
        }
        // menu secondario
        else
        {
          // se nn siamo in ultima pos
          for (i = 0; menu[mpos + 1][i] != 0; i++);
          if (lpos != i - 1)
          {
            olpos = lpos;
            lpos++;
          } else
            // ultima pos del list
          {
            olpos = lpos;
            lpos = 0;
          }

        }

        break;

        // se sono sul menu secondario e premo left va al
        // menu principale, altrimenti esce dai settings
      case KEY_LEFT:
        // sono nel menu principale
        if (where == 0)
        {
          mpos = 100;
          break;
        }
        // menu secondario
        else
        {
          owhere = where;
          olpos = lpos;
          lpos = where = 0;
        }
        break;

        // se sono nel menu principale passo al secondario
        // altrimenti svolgo la funzione selezionata
      case KEY_RIGHT:
      case 10:
      case 13:

        // menu principale
        if (where == 0)
        {
          owhere = where;
          where++;
          ompos = mpos;
          olpos = lpos = 0;
        }
        // sono in quello secondario
        else
        {
          // disseleziono 
          if (!net_optimize)
          {
            wattroff(wlist, A_REVERSE);
            mvwprintw(wlist, lpos + 2, 3, menu[mpos + 1][lpos]);
          } else
            mvwprintw(wlist, lpos + 2, 2, " ");
          sel(mpos, lpos);
          clear_w(wdata, 0);
          wrefresh(wdata);
          // TODO
          change = 1;
          curs_set(0);
          noecho();
          // riseleziono
          if (!net_optimize)
          {
            wattron(wlist, A_REVERSE);
            mvwprintw(wlist, lpos + 2, 3, menu[mpos + 1][lpos]);
          } else
            mvwprintw(wlist, lpos + 2, 2, ">");
        }
        break;
    }
  }

  if (change)
  {
    int ris[2];

    wprintw(wdata, "Do you want to save? [Y/n]: ");
    curs_set(2);
    ris[0] = wgetch(wdata);
    curs_set(0);
    if (ris[0] == 'y' || ris[0] == 'Y' || ris[0] == '\n'
        || ris[0] == KEY_LEFT)
    {
      logg("writing configuration\n");
      write_configuration(0);
    }
  }

  wattroff(wmain, A_REVERSE);
  clear_w(wmain, 0);
}



void
sel(ushort mpos, ushort lpos)
{
  char buff[513];

  curs_set(1);
  switch (mpos)
  {
      // general option
    case 0:
      switch (lpos)
      {
          // mail check time
        case 0:
          echo();
          do
          {
            wprintw(wdata, "Insert mail check time in minutes [%d]: ",
                    mail_check_time);
            wgetnstr(wdata, buff, 512);
            if (buff[0] == 0)
              return;
            if (buff[0] == '0')
              break;
          }
          while (atoi(buff) == 0);
          if (mail_check_time == 0 && atoi(buff) > 0)
          {
            mail_check_time = atoi(buff);
            pthread_create(&sleep_thread, NULL, (void *) timed, NULL);
          } else
            mail_check_time = atoi(buff);
          break;
          // change password
        case 1:
          do
          {
            wprintw(wdata, "Insert old password: ");
            wgetnstr(wdata, buff, 512);
            if (buff[0] == 0)
              return;
          }
          while (strlen(buff) < 2);
          break;
          // smtp server
        case 2:
          do
          {
            echo();
            curs_set(2);
            mvwprintw(wdata, 1, 0, "Insert smtp server [%s]: ",
                      smtpserver == NULL ? "" : smtpserver);
            wgetnstr(wdata, buff, 512);
            if (!buff[0])
              return;
          }
          while (strlen(buff) < 0);

          if (smtpserver != NULL)
            free(smtpserver);

          smtpserver = (char *) malloc(strlen(buff));
          strcpy(smtpserver, buff);

          do
          {
            wprintw(wdata, "You want an ssl connnenction [Y/n]: ");
            wgetnstr(wdata, buff, 1);
            tolow(buff, 1);
          }
          while (buff[0] != 'y' && buff[0] != 'n' && buff[0]);

          ssmtp = buff[0] != 'n' ? SSL_CONNECTION : CLEAR_CONNECTION;

          do
          {
            wprintw(wdata, "Insert the smtp server port [%d]: ",
                    ssmtp == SSL_CONNECTION ? 465 : 25);
            wgetnstr(wdata, buff, 5);
          }
          while (buff[0] && atoi(buff) == 0);

          smtpport =
            !buff[0] ? (ssmtp == SSL_CONNECTION ? 465 : 25) : atoi(buff);

          do
          {
            wprintw(wdata, "You need authentication [N/y]? ");
            wgetnstr(wdata, buff, 1);
            tolow(buff, 1);
          }
          while (buff[0] != 'y' && buff[0] != 'n' && buff[0]);

          if (buff[0] != 'y')
          {
            smtpauth = NOSMTPAUTH;
            info(2, "The new smtp server is %s\n", smtpserver);
            return;
          } else
            smtpauth = AUTH_LOGIN;

          wprintw(wdata, "Enter username: ");
          wgetnstr(wdata, buff, 30);
          smtpuser = (char *) malloc(strlen(buff));
          strcpy(smtpuser, buff);

          noecho();
          wprintw(wdata, "Enter password: ");
          wgetnstr(wdata, buff, 30);
          smtppass = (char *) malloc(strlen(buff));
          strcpy(smtppass, buff);

          info(2, "The new smtp server is %s\n", smtpserver);
          break;
          // change paranoy's dir
        case 3:
          wprintw(wdata, "Insert complete paranoy's directory: [%s]",
                  MAILDIR);
          wgetnstr(wdata, buff, 512);
          if (!buff[0])
            return;
          free(MAILDIR);
          MAILDIR = (char *) smalloc(strlen(buff));
          strcpy(MAILDIR, buff);
          break;
          // edit signature file
        case 4:
          break;
          // optimize remote use
        case 5:
          if (net_optimize)
          {
            info(0, "Unsetting net optimization\n");
            // delete old selection
            mvwprintw(wlist, 8, 2, " ");
            net_optimize = 0;
          } else
          {
            info(0, "Setting net optimization\n");
            // delete old selection
            wattroff(wlist, A_REVERSE);
            mvwprintw(wlist, 8, 3, "Optimize remote use");
            net_optimize = 1;
          }

          break;
          // put random signature 
        case 6:
          if (random_signature)
          {
            info(0, " Random signature disabled!\n");
            random_signature = 0;
          } else
          {
            info(0, " Random signature enabled!\n");
            random_signature = 1;
          }
          wrefresh(wdata);
          break;
          // simple mode
        case 7:
          if (mode == SMOKED)
          {
            info(0, " Normal mode enabled!\n");
            mode = NORMAL;
          } else if (mode == NORMAL)
          {
            info(0, " Simple mode enabled!\n");
            mode = SIMPLE;
          }
          // smoked mode :D TODO
          else
          {
            info(0, " dheheheh let's go with smoked mode :DDD\n");
            mode = SMOKED;
          }

          break;
          // set color
        case 8:
          set_color();
          break;
      }
      break;
      // accounts
    case 1:
      switch (lpos)
      {
          // new account
        case 0:
          add_account();
          break;
          // manage account
        case 1:
          if (naccount != 0)
            list_account();
          else
            info(2, " No account!\n");
          break;
      }
      break;
      // contacts
    case 2:
      switch (lpos)
      {
          // add contacts
        case 0:
          add_contact();
          break;
          // Menage contacs
        case 1:
          if (contact)
            list_contact();
          else
            info(2, "No contact!\n");
      }
      break;
      // Filters
    case 3:
      switch (lpos)
      {
          // new filter
        case 0:
          new_filter();
          break;
      }
      break;
      // PGP
    case 4:
      switch (lpos)
      {
        case 0:
          cur_gen_key();
          break;
      }
      break;
      // security
    case 5:
      switch (lpos)
      {
      }
      break;
      // anonimity
    case 6:
      switch (lpos)
      {
          // create nymserver account
        case 0:
          create_nym_account();
          break;
          // random latency time
        case 1:
          wprintw(wdata, " Do you want a random latent time [Y/n]?");
          wgetnstr(wdata, buff, 512);
          if (buff[0] == 0)
            buff[0] = 'y';
          buff[0] = tolower(buff[0]);
          wprintw(wdata, " Insert the offset time: ");
          wgetnstr(wdata, buff + 1, 511);
          if (buff[0] == 'y')
          {
            if (buff[1] != 0)
              snprintf(buff, 512, "+%sr", buff + 1);
            else
              snprintf(buff, 512, "+0:00");
          } else
          {
            if (buff[1] != 0)
              snprintf(buff, 512, "+%s", buff + 1);
            else
              strcpy(buff, buff + 1);
          }
          break;
          // deform mail size
        case 2:


          break;
      }
      break;
  }
  curs_set(0);
}
