/*
 * Copyright (C) 2003  
 * paranoy project - paranox.sf.net - paranoy@autistici.org
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */

#include "include.h"


struct connection *
smtp_session(struct email *mail)
{
  struct connection *c;
  char buff[BUFFER_REAL];
  char buff2[BUFFER_REAL];
  time_t t;
  struct tm *tim;
  byte n_bcc = 0, n_to = 0;
  FILE *file;
  byte bcc = 0;
  unsigned long i = 0;

  bzero(buff, BUFFER_REAL);
  logg("dentro la session\n");
  // TODO
  mail->nto = 1;
  c = (struct connection *) smalloc(sizeof(struct connection));

  c->sbio = NULL;
  c->state = SMTP_CONN;
  info(0, "Connection to %s", smtpserver);

  // try connection
  logg("prima della connessione %s %d - %d\n", smtpserver, smtpport, ssmtp);

  if (para_connect(c, smtpserver, smtpport, ssmtp))
    // in c->err there's the type of error
    return c;

  logg("dopo la session\n");
  info(0, "Connected..\n");
  logg("connesso smtp dimmorte\n");
  // read banner
  if (smtp_answer(c, buff) != SMTP_INIT)
    return c;

  logg("leggo il banner %s\n", buff);

  // send ehlo
  snprintf(buff, BUFFER_LEN, "EHLO %s\r\n", localhost);
  logg("Sto mandando %s\n", buff);
  para_write(c, buff);
  para_read(c, buff, BUFFER_LEN);
  logg("smtp - ricevo '%s'\n", buff);

  // check if user want authentication
  switch (ssmtp)
  {
    case NOSMTPAUTH:
      break;
    case AUTH_LOGIN:
      logg("mando AUTH LOGIN\n");
      para_write(c, "AUTH LOGIN\r\n");
      buff[para_read(c, buff, BUFFER_LEN)] = 0;
      logg("smtp - authentication .. read : %s\n", buff);
      sprintf(buff, smtpuser);
      base64_encode(buff, buff2);
      logg("base64 storia viene prima %s e poi %s,", buff, buff2);
      logg("smtp - authentication ..sending  %s\n", buff2);
      para_write(c, buff2);
      para_read(c, buff, BUFFER_LEN);
      logg("smtp - authentication .. read : %s\n", buff);
      sprintf(buff, smtppass);
      base64_encode(buff, buff2);
      strcat(buff2, "\r\n");
      para_write(c, buff2);
      logg("smtp - authentication ..sending  %s\n", buff2);
      para_read(c, buff, BUFFER_LEN);
      logg("smtp - authentication .. read : %s\n", buff);
      break;
    case AUTH_PLAIN:
      break;
    case AUTH_CRAM:
      break;
  }

  info(0, "Sending mail..");
  // send mail from
  snprintf(buff, BUFFER_LEN, "MAIL FROM:<%s>\r\n", mail->from);
  logg("Sto mandando \"%s\"\n", buff);
  if (smtp_send(c, buff) != SMTP_OK)
  {
    info(1, "Error while sending MAIL FROM");
    c->err = SMTP_ERROR;
    return c;
  }
  // send mail
  mail->nbcc = 0;
  mail->nto = 1;
  bcc = 0;
  for (n_bcc = 0; n_bcc <= mail->nbcc; n_bcc++)
  {
    if (bcc)
    {
      snprintf(buff, BUFFER_LEN, "RSET\r\n");
      if (smtp_send(c, buff) != SMTP_OK)
        return c;
    }
    // send rcpt to
    for (n_to = 0; n_to < mail->nto; n_to++)
    {
      snprintf(buff, BUFFER_LEN, "RCPT TO:<%s>\r\n",
               bcc ? mail->bcc[n_bcc] : mail->to[n_to]);
      logg("Sto mandando %s\n", buff);
      if (smtp_send(c, buff) != SMTP_OK)
      {
        info(1, "Error while sending RCPT TO");
        c->err = SMTP_ERROR;
        return c;
      }
      if (bcc)
      {
        n_bcc++;
        break;
      } else
        n_to++;
    }

    // sending data
    info(0, "Sending data...");
    snprintf(buff, BUFFER_LEN, "DATA\r\n");
    if (smtp_send(c, buff) != SMTP_DATA)
    {
      info(1, "Error while sending DATA");
      return c;
    }

    logg("mando il boundary %s\n", mail->boundary);
    if (mail->boundary)
    {
      snprintf(buff, BUFFER_LEN,
               "MIME-Version: 1.0\nContent-Type: multipart/mixed;\n\tboundary=\"%s\"\n",
               mail->boundary);
      if (para_write(c, buff) < 0)
        return c;
    }

    logg("Mando il subject\n");
    snprintf(buff, BUFFER_LEN, "Subject: %s\n",
             mail->subject ? mail->subject : "");
    if (para_write(c, buff) < 0)
      return c;

    logg("Mando mailer e data\n");
    sprintf(buff, "X-Mailer: paranoy %s (paranox.sf.net)\n", VERSION);
    para_write(c, buff);
    time(&t);
    tim = localtime(&t);
    strftime(buff, BUFFER_LEN, "Date: %a, %d %b %Y %H:%M:%S %z\n", tim);
    para_write(c, buff);

    sprintf(buff, "From: %s\n", mail->from);
    para_write(c, buff);


    logg("mando il to\n");
    snprintf(buff, BUFFER_LEN, "To: %s\n\n", mail->to[0]);
    para_write(c, buff);
    logg("mando il body\n");
    i = 0;

    if (mail->boundary)
    {
      snprintf(buff, BUFFER_LEN, "--%s\nContent-Type: text/plain;\n\n",  mail->boundary);
			para_write(c, buff);
		}
																			 
    // sending body
//    logg("sto per mandare il body che e' lungo %d.\n", mail->len);
    para_write(c, mail->body[0]);

    /*
     * while (i < mail->nline) { bzero(buff, BUFFER_REAL); logg("prima di
     * strncpy\n"); strncpy(buff, mail->body[i], BUFFER_LEN); logg("dopo
     * strncpy\n"); // i += strlen(buff); i++; logg("dopo strlen\n");
     * para_write(c, buff); logg("letti %d bytes di %d\n", i, mail->nline); }
     */

    logg("vedo se ci osno allegati %d\n", mail->nattach);
    if (mail->nattach)
    {
      // sending attachments
      for (i = 0; i < mail->nattach; i++)
      {
        snprintf(buff, BUFFER_LEN,
                 "\n\n--%s\nContent-Disposition: attachment; filename=\"%s\"\nContent-Transfer-Encoding: Base64\n\n",
                 mail->boundary, mail->attach[i]->name);
        para_write(c, buff);

        // qui lo encoda in base64
        snprintf(buff, BUFFER_LEN, "%s/%s", mail->attach[i]->path,
                 mail->attach[i]->name);
        logg("Dentro send aggiungo allegato %s\n", buff);
        // para_write(c, buff);
        file = fopen(buff, "r");
        i = 0;
        int pad = 0;

        while (!feof(file))
        {
          pad = fread(buff, 1, 3, file);
          buff[pad] = 0;
          base64_encode(buff2, buff);
          logg("encodo '%s' in '%s' e pad = %d\n", buff, buff2, pad);
          para_write(c, buff2);
          i++;
          if (i == 19)
          {
            para_write(c, "\n");
            i = 0;
          }
        }
        fclose(file);
      }
      snprintf(buff, BUFFER_LEN, "\n\n--%s--\n", mail->boundary);
      para_write(c, buff);
    }

    strncpy(buff, "\r\n.\r\n", BUFFER_LEN);
    para_write(c, buff);

    // read answer
    if (para_read(c, buff, BUFFER_LEN) < 0)
    {
      info(1, "Error while reading final answer");
      return c;
    }

    logg("finito...%s\n", buff);
  }
  info(0, "Quitting\n");

  strncpy(buff, "QUIT\r\n", 512);
  para_write(c, buff);
  para_close(c);
  c->err = NO_ERROR;
  return c;
}

ushort
smtp_answer(struct connection * c, char *buff)
{
  if (para_read(c, buff, 512) < 0)
    return SOCKET_READ_ERROR;
  logg("Dentro smtp_answer leggo %s\n", buff);
  buff[3] = 0;
  return atoi(buff);
}

ushort
smtp_send(struct connection * c, char *buff)
{
  if (para_write(c, buff) < 0)
    return SOCKET_WRITE_ERROR;
  return (smtp_answer(c, buff));
}
