/*
 * Copyright (C) 2003  
 * paranoy project - paranox.sf.net - paranoy@autistici.org
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */

#include "include.h"
byte
para_connect(struct connection * c, char *host, ushort port, ushort type)
{
  SSL_CTX *ctx;
  SSL *ssl;
  struct sockaddr_in address;
  struct hostent *hp;
  char *s = (char *) malloc(40);

  // hp = (struct hostent *) smalloc(sizeof(struct hostent));
  // ssl = (SSL *) smalloc(sizeof(SSL));
  logg("Mi sto connettendo all'host  %s alla porta %d\n", host, port);

  // ssl connection
  if (type == SSL_CONNECTION)
  {
    logg("dentro ssl connection\n");


    /*
     * SSL_CTX_new() creates a new SSL_CTX object as framework to establish 
     * TLS/SSL enabled connections. The SSL_CTX object uses method as
     * connection method. The methods exist in a generic type (for client
     * and server use), a server only type, and a client only type. method
     * can be of the following types: SSLv3_method(void),
     * SSLv3_server_method(void), SSLv3_client_method(void) A TLS/SSL
     * connection established with these methods will only understand the
     * SSLv3 protocol. A client will send out SSLv3 client hello messages
     * and will indicate that it only understands SSLv3. A server will only 
     * understand SSLv3 client hello messages. This especially means, that
     * it will not understand SSLv2 client hello messages which are widely
     * used for compatibility reasons, see SSLv23_*_method(). 
     */


    logg("primo ssl\n");
    ctx = SSL_CTX_new(SSLv23_client_method());
    SSL_CTX_set_timeout(ctx, 5);
    /*
     * BIO_new_ssl_connect() creates a new BIO chain consisting of an SSL
     * BIO (using ctx) followed by a connect BIO. 
     */
    c->sbio = BIO_new_ssl_connect(ctx);

    /*
     * BIO_get_ssl() retrieves the SSL pointer of BIO b, it can then be
     * manipulated using the standard SSL library functions. 
     */
    BIO_get_ssl(c->sbio, &ssl);

    if (!ssl)
    {
      info(2, "Error: loading ssl: ");
      c->err = 1;
      return 1;
    }
    logg("secondo ssl\n");
    /*
     * SSL_MODE_AUTO_RETRY Never bother the application with retries if the 
     * transport is blocking.  If a renegotiation take place during normal
     * operation, a SSL_read(3) or SSL_write(3) would return with -1 and
     * indicate the need to retry with SSL_ERROR_WANT_READ. In a
     * non-blocking environment applications must be prepared to handle
     * incomplete read/write operations.  In a blocking environment,
     * applications are not always prepared to deal with read/write
     * operations returning without success report. The flag
     * SSL_MODE_AUTO_RETRY will cause read/write operations to only return
     * after the handshake and successful completion. 
     */
    logg("prima del setmode\n");
    SSL_set_mode(ssl, SSL_MODE_AUTO_RETRY);



    /*
     * BIO_set_conn_hostname() uses the string name to set the hostname The 
     * hostname can be an IP address. The hostname can also include the
     * port in the form hostname:port It is also acceptable to use the
     * form "hostname/any/other/path" or "hostname:port/any/other/path". 
     */
    logg("dopo il set mode\n");
    sprintf(s, "%s:%d", host, port);
    logg("ssl si connette a %s\n", s);
    if (BIO_set_conn_hostname(c->sbio, s) < 0)
    {
      info(2, "Error: setting up %s: check it!\n");
      c->err = SSL_CONNECTION_ERROR;
      return 1;
    }
    logg("son qui fuori dall'errore\n");




    /*
     * BIO_do_connect() attempts to connect the supplied BIO. It returns 1
     * if the connection was established successfully. A zero or negative
     * value is returned if the connection could not be established 
     */
    logg("tento la connession..\n");
    if (BIO_do_connect(c->sbio) <= 0)
    {
      info(2, "Error: ssl connection to %s: check it!", host);
      logg("errore nella connessione in ssl\n");
      // BIO_free_all(c->sbio);
      c->err = SSL_CONNECTION_ERROR;
      return 1;
    }
    logg("dopo la connessione\n");
    /*
     * BIO_do_handshake() attempts to complete an SSL handshake on the
     * supplied BIO and establish the SSL connection. It returns 1 if the
     * connection was established successfully. A zero or negative value is 
     * returned if the connection could not be established 
     */

    if (BIO_do_handshake(c->sbio) <= 0)
    {
      info(2, "Error: ssl connection to %s: check it!", host);
      BIO_free_all(c->sbio);
      c->err = SSL_CONNECTION_ERROR;
      return 1;
    }
    logg("connesso in ssl trankilo\n");
    return 0;
  }
  // clear connection
  else
  {

    logg("Clear connection dimmorte\n");
    if ((c->sock = socket(PF_INET, SOCK_STREAM, 0)) < 0)
    {
      info(1, "Error in socket...");
      c->err = 1;
      return 1;
    }
    logg("prima di gethostbuyname\n");
    if ((hp = gethostbyname(host)) == NULL)
    {
      logg("errore bekka risoluzione del dominio\n");
      info(1, "Error while resolving %s", host);
      c->err = 1;
      return 1;
    }
    logg("son ancora dentro la connessione\n");
    memset(&address, 0, sizeof(address));
    memcpy((char *) &address.sin_addr, hp->h_addr, hp->h_length);
    address.sin_family = AF_INET;
    address.sin_port = htons((u_short) port);

    {
      fd_set fd;
      struct timeval tv;
      socklen_t optlen;
      int optval, rc;

      if (!connect_timeout)
        return connect(c->sock, (struct sockaddr *) &address,
                       sizeof(address));

      tv.tv_sec = connect_timeout;
      tv.tv_usec = 0;


      if (fcntl(c->sock, F_SETFL, O_NONBLOCK < 0))
      {
        free(c);
        return -1;
      }



      logg("socket - porima di connect\n");

      if (connect(c->sock, (struct sockaddr *) &address, sizeof(address)) ==
          0)
      {
        logg("socket - gia' connesso\n");
        return 0;
      }


      if (errno != EINPROGRESS)
      {
        logg("socket - not einprogress %s\n", strerror(errno));
        return -1;
      }


      FD_ZERO(&fd);
      FD_SET(c->sock, &fd);

      while (1)
      {
        rc = select(c->sock + 1, NULL, &fd, NULL, &tv);

        if (rc != -1 || errno != EINTR)
          break;
      }
      switch (rc)
      {
        case 0:
          logg("socket- TIMEOUT\n");
          free(c);
          return -1;
        case -1:
          logg("socket - select error\n");
          free(c);
          return -1;
        case 1:
          optval = 0;
          optlen = sizeof(optval);
          if (getsockopt(c->sock, SOL_SOCKET, SO_ERROR, &optval, &optlen) < 0)
          {
            logg("socket - error in getsocktopt\n");
            free(c);
            return -1;
          }
          if (optval != 0)
          {
            logg("socket - error in getsockopt %s\n", strerror(errno));
            free(c);
            return -1;
          }
          return 0;
      }
    }

  }
  return 1;
}

int
para_read(struct connection *c, char *s, ushort size)
{
  if (c->sbio != NULL)
    return BIO_read(c->sbio, s, size);
  else
  {
    int i;

    if (timedrread(c->sock, 30))
    {
      i = read(c->sock, s, size);
      s[i] = 0;
      return i;
    } else
    {
      c->err = SOCKET_TIMEOUT;
      return -1;
    }
  }


}


int
para_write(struct connection *c, const char *s)
{
  if (c->sbio == NULL)
    return write(c->sock, s, strlen(s));
  else
    return BIO_puts(c->sbio, s);
}

void
para_close(struct connection *c)
{
  logg("socket - dentro para_close\n");
  if (c->sbio == NULL)
    shutdown(c->sock, 2);
  else
  {
    logg("socket - ora closo la connessione in ssl\n");
    BIO_ssl_shutdown(c->sbio);
    logg("socket - vai di free all\n");
    BIO_free_all(c->sbio);
  }
}

int
timedrselect(fd_set * rfds, int max, int time)
{
  struct timeval timeout;

  timeout.tv_sec = time;
  timeout.tv_usec = 0;

  if (select(max, rfds, NULL, NULL, &timeout) <= 0)
    return 1;
  return 0;
}

/*
 * prepare the socket to be read 
 */
int
timedrread(int sock, int time)
{
  fd_set rfds;

  FD_ZERO(&rfds);
  FD_SET(sock, &rfds);
  timedrselect(&rfds, sock + 1, time);
  return FD_ISSET(sock, &rfds);
}

int
recvline(struct connection *cn, void *vptr, int maxlen)
{
  int n, rc;
  char c, *ptr;


  ptr = vptr;
  for (n = 1; n < maxlen; n++)
  {
    rc = readch(cn, &c);


    if (rc == 1)
    {
      if (c == '\r')
      {
        // read the \n
        readch(cn, &c);
        n--;
        // continue;
        break;
      }
      if (c == '\n')
      {
        // n--;
        break;
      }
      *ptr++ = c;
    } else if (rc == 0)
    {
      if (n == 1)
      {
        *ptr = '\0';
        return 0;               /* EOF, no data read */
      } else
        break;                  /* EOF, some data read */
    } else
      return -1;                /* error, errno set by read() */
  }

  *ptr = 0;                     /* null terminate like fgets() */

  return n;
}

int
readch(struct connection *c, char *ptr)
{
  static int read_cnt = 0;
  static char *read_ptr;
  static char read_buf[512];

  if (read_cnt <= 0)
  {
    if ((read_cnt = para_read(c, read_buf, sizeof(read_buf))) < 0)
      return -1;
    else if (read_cnt == 0)
      return 0;
    read_ptr = read_buf;
  }
  read_cnt--;
  *ptr = *read_ptr++;
  return 1;
}
