/*
 * Copyright (C) 2003  
 * paranoy project - paranox.sf.net - paranoy@autistici.org
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */

#include "include.h"

#define NORMAL 0
#define SELECT 1
#define CRYPT 'k'
#define ANON 	'f'
#define SIGN	'c'
#define ATTACH 'z'
#define SUBJECT 's'
#define TO 't'
#define SEND 'x'
#define SAVE 'v'
#define BCC 'b'

void print_compose_menu(byte pos, byte obj[], byte type, struct email *mail);

void
compose(struct email *rmail, byte empty_reply_forward)
{

  struct email *mail;
  struct lines *head;

  // struct folders *fold;
  byte i, pos = 0;
  byte obj[13 + naccount];
  char **p, *man_from;
  int c;
  man_from = (char *) malloc(sizeof(char) * 50);
  *man_from = 0;

  // if we have some draft mail, ask to send them
  /*
   * fold=search_folder("draft"); if (fold) { logg("sono qui dentro e ho
   * trovato draft e fold = %p e fold->nall %d\n",fold,fold->nall); if
   * (fold->nall!=0) { list_email(fold,0); return; } } 
   */

  clear_w(wmain, 0);
  title("Compose");
  if (wcompose == NULL)
  {
    wcompose = newwin(naccount + 14, COLS, 1, 0);
    weditor = newwin(LINES - (naccount + 17), COLS, naccount + 16, 0);
    keypad(wcompose, TRUE);
    keypad(weditor, TRUE);
  }
  wattroff(wcompose, A_REVERSE);
  wborder(wcompose, 0, 0, 0, 0, 0, 0, 0, 0);
  clear_w(wcompose, 1);
  mail = (struct email *) malloc(sizeof(struct email));

  switch (empty_reply_forward)
  {
      // new email
    case 0:
      mail->subject = NULL;
      mail->body = NULL;
      mail->nto = 0;
      mail->nattach = 0;
      mail->boundary = NULL;
      mail->nbcc = 0;
      mail->to = (char **) malloc(2 * sizeof(char *));
      mail->to[0] = NULL;
      mail->enc = FALSE;
      mail->sign = FALSE;
      mail->anon = FALSE;
      mail->bcc = NULL;
      mail->attach = NULL;
      mail->header = NULL;
      mail->body = NULL;
      mail->head_lines = 0;
      mail->body_lines = 0;

      break;

      // reply and reply to
    case 1:
    case 3:
      {
        struct lines *temp = NULL;

        logg("dentro reply\n");
        mail->subject =
          (char *) malloc(strlen(rmail->subject ? rmail->subject : "") + 5);
        sprintf(mail->subject, "Re: %s",
                rmail->subject ? rmail->subject : "");
        c = 1;
        mail->nto = 1;
        mail->to = (char **) malloc(sizeof(char *));
        logg("prima di strdup\n");
        mail->to[0] = strdup(rmail->from ? rmail->from : "");
        mail->enc = FALSE;
        mail->sign = FALSE;
        mail->anon = FALSE;
        mail->nbcc = 0;
        mail->inreplyto = rmail->messageid ? strdup(rmail->messageid) : NULL;
        mail->bcc = NULL;
        mail->nattach = 0;
        mail->attach = NULL;
        logg("prima di text\n");
        text = (struct lines *) malloc(sizeof(struct lines));
        text->data = NULL;
        text->prev = NULL;
        text->next = NULL;
        text->l = 0;

        p = (char **) rmail->body;
        head = text;
        while (*p)
        {
          text->l = strlen(*p) + 2;
          text->data = (char *) smalloc(text->l + 1);
          sprintf(text->data, "> %s", *p);
          text->next = (struct lines *) malloc(sizeof(struct lines));
          text->prev = temp;
          temp = text;
          if (c < LINES - naccount + 9)
            print_line(weditor, c - 1, text->data);
          p++;
          c++;
          text = text->next;
          text->next = NULL;
          text->data = NULL;
        }
        text = head;
        pos = naccount + 9;
      }
  }

  wrefresh(wmain);

  refresh();
  obj[0] = 'A';
  for (i = 1; i < naccount; i++)
    obj[i] = 'a';

  // wattroff(wmain, A_REVERSE);
  // write the screen the first time..
  mvwprintw(wcompose, 1, 2, "From :");
  for (i = 0; i < naccount; i++)
    mvwprintw(wcompose, i + 2, 3, "[ ] %s", account[i]->email);

  i = naccount;
  obj[i] = 'a';
  mvwprintw(wcompose, 2 + i++, 3, "[ ] Manual from:");
  obj[i] = ANON;
  mvwprintw(wcompose, 2 + i++, 3, "[ ] Anonymous sending");
  dsign ? (mail->sign = TRUE) : (mail->sign = FALSE);
  obj[i] = SIGN;
  mvwprintw(wcompose, 2 + i++, 2, "[%c] Sign email", dsign ? 'X' : ' ');
  obj[i] = CRYPT;
  mvwprintw(wcompose, 2 + i++, 2, "[ ] Encrypt email");
  obj[i] = SUBJECT;
  mvwprintw(wcompose, 2 + i++, 2, "Subject: %s",
            mail->subject ? mail->subject : "");
  obj[i] = TO;
  mvwprintw(wcompose, 2 + i++, 2, "To: %s", mail->to[0] ? mail->to[0] : "");
  obj[i] = BCC;
  mvwprintw(wcompose, 2 + i++, 2, "Bcc:");
  obj[i] = ATTACH;
  mvwprintw(wcompose, 2 + i++, 2, "Add Attach");
  obj[i] = SEND;
  mvwprintw(wcompose, 2 + i++, 2, "Send mail");
  obj[i] = SAVE;
  mvwprintw(wcompose, 2 + i, 2, "Save draft");
  i = 0;

  print_compose_menu(pos, obj, SELECT, mail);
  refresh();
  wrefresh(wcompose);
  wrefresh(weditor);
  while (1)
  {
    if (i != pos)
    {
      wattrset(wcompose, A_NORMAL);
      // normalize old selection
      print_compose_menu(i, obj, NORMAL, mail);

      // select new choose
      print_compose_menu(pos, obj, SELECT, mail);
    }
    wrefresh(wcompose);
    switch (c = wgetch(wcompose))
    {
      case KEY_F(1):
      case 'h':
      case '?':
        help("compose");
        // qui dovrebbe riprintare tutto ma nn lo fara mai TODO
        break;
      case 'q':
      case ESC:
      case KEY_LEFT:
        wattroff(wmain, A_REVERSE);
        free(mail->to);
        free(mail);
        // free del testo
        if (text != NULL)
        {
          while (text->next != NULL)
          {
            free(text->data);
            text = text->next;
            free(text->prev);
          }
          free(text->data);
          free(text);
        }
        text = NULL;
        clear_w(wmain, 0);
        return;
      case KEY_DOWN:
        logg("premo down dentro la compose\n");
        if (pos < naccount + 9)
        {
          logg("sono nei tasti\n");
          i = pos;
          pos++;
        } else
        {
          logg("lancio editor\n");
          edit();
        }
        break;
      case KEY_UP:
        if (pos > 0)
        {
          i = pos;
          pos--;
        }
        break;
      case ENTER:
      case KEY_RIGHT:
      case 32:
        if (obj[pos] == 'a')
        {
          for (i = 0; i < naccount + 1; i++)
          {
            if (obj[i] == 'A')
            {
              obj[i] = 'a';
              print_compose_menu(i, obj, NORMAL, mail);
            }
          }
          if (pos < naccount + 1)
          {
            if (man_from != NULL)
            {
              for (i = 0; i < strlen(man_from) + 1; i++)
                mvwprintw(wcompose, naccount + 2, 20 + i, " ");
              wrefresh(wcompose);
              man_from = NULL;
            }
          }
          obj[pos] = 'A';
          print_compose_menu(pos, obj, SELECT, mail);
          i = pos;
        } else if (pos == naccount) // se selezionato Manual from 
        {
          man_from = edit_string(man_from, naccount + 2, 21, wcompose);
        } else if (obj[pos] == ANON)
        {
          mail->anon = mail->anon == TRUE ? FALSE : TRUE;
          print_compose_menu(pos, obj, SELECT, mail);
        } else if (obj[pos] == SUBJECT)
          mail->subject = edit_string(mail->subject, pos + 2, 11, wcompose);
        else if (obj[pos] == TO)
          mail->to[mail->nto] =
            edit_string(mail->to[mail->nto], pos + 2, 6, wcompose);

        else if (obj[pos] == BCC)
          mail->bcc[mail->nbcc] =
            edit_string(mail->bcc[mail->nbcc], pos + 2, 7, wcompose);
        else if (obj[pos] == ATTACH)
        {
          add_attach(mail);
          clear_w(wmain, 0);
          wattrset(wmain, A_NORMAL);
          wrefresh(wmain);
          wattrset(wcompose, A_NORMAL);
          mvwprintw(wcompose, 1, 2, "From :");
          for (i = 0; i < naccount; i++)
            mvwprintw(wcompose, i + 2, 3, "[ ] %s", account[i]->email);
          i = naccount;
          obj[i] = 'a';
          mvwprintw(wcompose, 2 + i++, 3, "[ ] Manual from: ");
          obj[i] = ANON;
          mvwprintw(wcompose, 2 + i++, 3, "[ ] Anonymous sending");
          dsign ? (mail->sign = TRUE) : (mail->sign = FALSE);
          obj[i] = SIGN;
          mvwprintw(wcompose, 2 + i++, 2, "[%c] Sign email",
                    dsign ? 'X' : ' ');
          obj[i] = CRYPT;
          mvwprintw(wcompose, 2 + i++, 2, "[ ] Encrypt email");
          obj[i] = SUBJECT;
          mvwprintw(wcompose, 2 + i++, 2, "Subject:");
          obj[i] = TO;
          mvwprintw(wcompose, 2 + i++, 2, "To:");
          obj[i] = BCC;
          mvwprintw(wcompose, 2 + i++, 2, "Bcc:");
          obj[i] = ATTACH;
          mvwprintw(wcompose, 2 + i++, 2, "Add Attach");
          obj[i] = SEND;
          mvwprintw(wcompose, 2 + i++, 2, "Send mail");
          obj[i] = SAVE;
          mvwprintw(wcompose, 2 + i, 2, "Save draft");
          i = 0;
          wborder(wcompose, 0, 0, 0, 0, 0, 0, 0, 0);
          print_compose_menu(pos, obj, SELECT, mail);
          refresh();
          wrefresh(wcompose);
          wrefresh(weditor);

        } else if (obj[pos] == SIGN)
        {
          mail->sign = mail->sign == TRUE ? FALSE : TRUE;
          // print_compose_menu(pos,obj,mail->sign==YES?SELECT:NORMAL,mail);
        } else if (obj[pos] == CRYPT)
        {
          mail->enc = mail->enc == TRUE ? FALSE : TRUE;
        } else if (obj[pos] == SEND)
        {
          // seleziona il from
          for (i = 0; i < naccount + 3; i++)
            if (obj[i] == 'A')
              break;
          if (obj[i] != 'A')
          {
            info(1, "You have to select a from!");
            break;
          }
          // il from scelto e' un account
          if (i < naccount)
          {
            mail->from = (char *) malloc(strlen(account[i]->email) + 1);
            strcpy(mail->from, account[i]->email);
          }
          // il from scelto e' manual
          else if (i == naccount)
          {
            if (!is_mail(man_from))
            {
              info(2, "Insert valid from");
              break;
            }

            mail->from = strdup(man_from);
          } else
          {
            mail->anon = TRUE;
            mail->from = strdup(account[0]->email);
          }

          if (!smtpserver[0])
          {
            info(2, "No smtp server!");
            break;
          }

          logg("avvio send mail\n");
          send_mail(mail);
          free_mail(mail);
          logg("dopo send_mail\n");
          wattroff(wcompose, A_REVERSE);
          wattroff(wmain, A_REVERSE);

          text = NULL;
          clear_w(wmain, 0);
          return;
        } else if (obj[pos] == SAVE)
        {
          // seleziona il from
          for (i = 0; i < naccount + 3; i++)
            if (obj[i] == 'A')
              break;
          if (obj[i] != 'A')
          {
            info(1, "You have to select a from!");
            break;
          }
          // il from scelto e' un account
          if (i < naccount)
          {
            mail->from = (char *) malloc(strlen(account[i]->email) + 1);
            strcpy(mail->from, account[i]->email);
          }
          // il from scelto e' manual
          else if (i == naccount)
          {
            if (!is_mail(man_from))
            {
              info(2, "Insert valid from");
              break;
            }

            mail->from = strdup(man_from);
          } else
          {
            mail->anon = TRUE;
            mail->from = strdup(account[0]->email);
          }

          save_draft(mail);
          clear_w(wmain, 0);
          wrefresh(wmain);
          return;
        }

        break;
      default:
        ungetch(c);
        if (obj[pos] == SUBJECT)
          mail->subject = edit_string(mail->subject, pos + 2, 11, wcompose);
        else if (obj[pos] == TO)
          mail->to[0] = edit_string(mail->to[0], pos + 2, 6, wcompose);
        // we are in manual from
        else if (naccount == pos)
        {
          // deseleziona il from selezionato (gli A in a)
          if (obj[pos] != 'A')
            for (i = 0; i < naccount + 1; i++)
              if (obj[i] == 'A')
              {
                obj[i] = 'a';
                print_compose_menu(i, obj, NORMAL, mail);
              }
          // seleziona il manual from
          obj[pos] = 'A';

          // ristampa il menu
          print_compose_menu(pos, obj, SELECT, mail);

          // edita il manual from
          man_from = edit_string(man_from, naccount + 2, 21, wcompose);
        } else
          wgetch(wcompose);
        break;
    }
  }
}

void
print_compose_menu(byte pos, byte obj[], byte type, struct email *mail)
{
  if (!net_optimize)
  {
    if (type == SELECT)
      wattron(wcompose, A_REVERSE);
    else
      wattroff(wcompose, A_REVERSE);

    if (obj[pos] == 'a' || obj[pos] == 'A')
    {
      if (pos < naccount)
        mvwprintw(wcompose, pos + 2, 3, "[%c] %s",
                  (obj[pos] == 'A' ? 'X' : ' '), account[pos]->email);
      else if (pos == naccount)
        mvwprintw(wcompose, pos + 2, 3, "[%c] Manual from:",
                  obj[pos] == 'A' ? 'X' : ' ');
    } else
    {
      if (obj[pos] == ANON)
        mvwprintw(wcompose, pos + 2, 3, "[%c] Anonymous sending",
                  mail->anon == TRUE ? 'X' : ' ');
      else if (obj[pos] == SIGN)
        mvwprintw(wcompose, pos + 2, 2, "[%c] Sign email",
                  mail->sign ? 'X' : ' ');

      else if (obj[pos] == CRYPT)
        mvwprintw(wcompose, pos + 2, 2, "[%c] Encrypt email",
                  mail->enc ? 'X' : ' ');
      else if (obj[pos] == SUBJECT)
        mvwprintw(wcompose, pos + 2, 2, "Subject:");
      else if (obj[pos] == TO)
        mvwprintw(wcompose, pos + 2, 2, "To:");
      else if (obj[pos] == BCC)
        mvwprintw(wcompose, pos + 2, 2, "Bcc:");
      else if (obj[pos] == ATTACH)
        mvwprintw(wcompose, pos + 2, 2, "Add Attach");
      else if (obj[pos] == SEND)
        mvwprintw(wcompose, pos + 2, 2, "Send mail");
      else if (obj[pos] == SAVE)
        mvwprintw(wcompose, pos + 2, 2, "Save draft");
    }
  } else
  {
    if (type == SELECT)
      mvwprintw(wcompose, pos + 2, 1, ">%s",
                obj[pos] == 'A' ? " [X]" : (obj[pos] == 'a' ? " [ ]" : ""));
    else
      mvwprintw(wcompose, pos + 2, 1, " %s",
                obj[pos] == 'A' ? " [X]" : (obj[pos] == 'a' ? " [ ]" : ""));
  }

}

void
save_draft(struct email *mail)
{
  char buff[BUFFER_REAL];
  struct folders *fold;
  struct lines *cur = text;

  strncpy(buff, "draft", BUFFER_LEN);
  fold = search_folder(buff);



  // se nn esiste lo creo
  if (!fold)
  {
    fold = new_folder(buff);

    if (fold == NULL)
    {
      info(2, "Error creating directory to store drafts");
      return;
    }
  }

  mail->level = 0;
  mail->boundary = NULL;
  mail->type = NEW;
  mail->nattach = 0;
  mail->date = NULL;
  mail->messageid = message_id();
  mail->uidl = MD5String(strdup(mail->messageid));
  add_mail(fold, mail);
  logg("lancio save_mail dentro save_draft\n");
  save_mail(mail, 1);
  write_index(fold);

  while (cur)
  {
    free(cur->data);
    cur = cur->next;
  }

  info(2, "Draft saved");
  return;


}
