#include "include.h"

/*
 * static const char *weekday_names[] = { "Sun", "Mon", "Tue", "Wed", "Thu",
 * "Fri", "Sat" }; 
 */
const char *month_names[14] = {
  "Jan", "Feb", "Mar", "Apr", "May", "Jun",
  "Jul", "Aug", "Sep", "Oct", "Nov", "Dec", "   ", NULL
};


/*
 * parse a date formatted like: "Sun, 13 Apr 2004 +200" and return a filled
 * tm struct
 */
struct tm *
rfcdate(char *date)
{
  char *cp = date, *x;
  struct tm *t;

  int i;

  t = (struct tm *) malloc(sizeof(struct tm));
  if ((cp = nexttoken(cp)) == NULL)
    return NULL;
  if (cp[0] < 127 && cp[1] < 127 && cp[2] < 127 && cp[3] == ',')
  {
    if ((cp = nexttoken(&cp[4])) == NULL)
      return NULL;
  }
  t->tm_mday = strtol(cp, &x, 10);
  if ((cp = nexttoken(x)) == NULL)
    return NULL;
  for (i = 0; month_names[i]; i++)
  {
    if (strncmp(cp, month_names[i], 3) == 0)
      break;
  }
  if (month_names[i] == NULL)
    return NULL;
  t->tm_mon = i + 1;
  if ((cp = nexttoken(&cp[3])) == NULL)
    return NULL;
  t->tm_year = strtol(cp, &x, 10);
  if ((cp = nexttoken(x)) == NULL)
    return NULL;
  t->tm_hour = strtol(cp, &x, 10);
  if (*x != ':')
    return NULL;
  cp = &x[1];
  t->tm_min = strtol(cp, &x, 10);
  if (*x == ':')
  {
    cp = &x[1];
    t->tm_sec = strtol(cp, &x, 10);
  } else
    t->tm_sec = 0;
  /*
   * if ((cp = nexttoken(x)) != NULL) { int sign = -1; char buf[3];
   * 
   * switch (*cp) { case '-': sign = 1; case '+': cp++; } if (cp[0]<127 &&
   * cp[1]<127 && cp[2]<127 && cp[3] < 127) { buf[2] = '\0'; buf[0] = cp[0];
   * buf[1] = cp[1]; t += strtol(buf, NULL, 10) * sign * 3600; buf[0] =
   * cp[2]; buf[1] = cp[3]; t += strtol(buf, NULL, 10) * sign * 60; } } 
   */
  return t;
}

char *
date_descr(struct email *mail, char *buff)
{
  time_t t;

  time(&t);
  struct tm *tim = localtime(&t);

  logg("dentro date_descr\n");

  if (!mail->date)
    return "";

  logg("dentro ques'if\n");
  // if we are in the same day
  if (mail->date->tm_mday == tim->tm_mday &&
      mail->date->tm_mon == tim->tm_mon + 1)
    snprintf(buff, BUFFER_LEN, " %2d:%2d  ", mail->date->tm_hour,
             mail->date->tm_min);
  else
  {
    if (mail->date->tm_mon == 0 || mail->date->tm_mon > 11)
      mail->date->tm_mon = 1;
    snprintf(buff, BUFFER_LEN, "%2d %s  ", mail->date->tm_mday,
             month_names[mail->date->tm_mon - 1]);
  }
  logg("prima del return dentro date_Descr\n");
  return buff;
}
