#include <gtk/gtk.h>
#include <gtk/gtk.h>

#define ACCOUNT_MENU  1
#define CONTACTS_MENU 2
#define GOPTION_MENU  0
#define FILTERS_MENU  3
#define SECUR_MENU    5
#define ANON_MENU     6
#define PGP_MENU      4



void on_plugin_select(GtkWidget * widget, gpointer * expander);

void event_press_on_mail_address(GtkWidget * menuitem, GdkEventButton * event,
                                 struct email *mail);

char *format_from(char *str, int mode);
int event_press_on_mail_list(GtkWidget * menuitem, GdkEvent * user_data);
int event_press_on_fold_list(GtkWidget * menuitem, GdkEvent * user_data);

struct contacts *catch_contacts_selection(GtkListStore * model,
                                          GtkTreeView * tree);

struct contacts_group *catch_group_selection(GtkListStore * model,
                                             GtkTreeView * tree);

struct email *catch_mail_selection(GtkListStore * model, GtkTreeView * tree);
struct folders *catch_fold_selection(GtkListStore * model,
                                     GtkTreeView * tree);

void on_okalert_button_clicked(GtkButton * button, GtkWidget * dialog);

void on_new_group_activate(GtkWidget * widget, gpointer user_data);
void on_newgroup_done(GtkWidget * widget, gpointer user_data);

void print_contacts_group();
void print_contacts();

void on_foldtree_dnd_receive(GtkWidget * wgt, GdkDragContext * context, int x,
                             int y, GtkSelectionData * seldata, guint info,
                             guint time, gpointer userdata);

void on_fold_tree_drag_begin(GtkWidget * w, GdkDragContext * context,
                             GtkSelectionData * selectiondata, guint info,
                             guint time, gpointer dummy);

void on_cancel_button_clicked(GtkButton * button, GtkWidget * window);

void on_delete_folder_activate(GtkWidget * widget, gpointer user_data);
void on_new_folder_activate(GtkWidget * widget, gpointer user_data);

void on_new_mail_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_from_file_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_posponed_mail_activate(GtkMenuItem * menuitem, gpointer user_data);

void
on_from_contacts_menu_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_prova_figlio1_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_get_mail_activate(GtkMenuItem * menuitem, gpointer user_data);


void on_search_change(GtkWidget * entry, gpointer user_data);

void on_get_mail_enter(GtkButton * button, gpointer user_data);


void on_get_mail_for_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_prova_for1_activate(GtkMenuItem * menuitem, gpointer user_data);

void
on_sent_postponed_mail_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_accounts_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_contacts_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_general_options_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_filters_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_pgp_item_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_security_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_anonimity_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_compose_activate(GtkMenuItem * menuitem, struct email *mail);

void on_help_paranoy1_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_help_pgp_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_about_email_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_fold_changed(GtkTreeView * treeview, gpointer user_data);
void on_group_changed(GtkTreeView * treeview, gpointer user_data);
void on_contact_changed(GtkTreeView * treeview, gpointer user_data);

gboolean on_settings_window_destroy_event(GtkWidget * widget,
                                          GdkEvent * event,
                                          gpointer user_data);
void on_addsign_button_clicked(GtkButton * button, gpointer user_data);

void on_from_file_open_clicked(GtkButton * button, gpointer user_data);

void on_from_file_cancel_clicked(GtkButton * button, gpointer user_data);

void on_open_mail_activate();

void on_moveto_activate(GtkMenuItem * menuitem, char *folder);

void on_reply_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_reply_all_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_forward_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_edit_as_new_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_move_to_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_provafiglio_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_copy_to_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_delete_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_delgroup_button_clicked(GtkButton * button, gpointer user_data);
void delgroup_clicked(GtkButton * button, GtkWidget * window);

void on_mainquit_button_clicked(GtkButton * button, gpointer user_data);

void on_addfilterok_button_clicked(GtkButton * button, gpointer user_data);

void on_addrole_button_clicked(GtkButton * button, gpointer user_data);

void on_delrole_button_clicked(GtkButton * button, gpointer user_data);

void on_modsign_button_clicked(GtkButton * button, gpointer user_data);

void on_delsign_button_clicked(GtkButton * button, gpointer user_data);

void on_settingapply_button_clicked(GtkButton * button, gpointer user_data);

void on_settingcancel_button_clicked(GtkButton * button, gpointer user_data);

void on_settingok_button_clicked(GtkButton * button, gpointer user_data);

void on_account_button_clicked(GtkButton * button, gpointer user_data);

void on_accountcancel_button_clicked(GtkButton * button, gpointer user_data);


void on_addaccount_button_clicked(GtkButton * button, gpointer user_data);

void on_modaccount_button_clicked(GtkButton * button, gpointer user_data);

void on_delaccount_button_clicked(GtkButton * button, GtkWidget * window);

void on_contactok_button_clicked(GtkButton * button, gpointer user_data);

void on_contactadd_button_clicked(GtkButton * button, gpointer user_data);

void on_contactmod_button_clicked(GtkButton * button, gpointer user_data);

void on_contactdel_button_clicked(GtkButton * button, gpointer user_data);

void on_filteradd_button_clicked(GtkButton * button, gpointer user_data);

void on_filtermod_button_clicked(GtkButton * button, gpointer user_data);

void on_filterddel_button_clicked(GtkButton * button, gpointer user_data);

gboolean
on_parapass_window_destroy_event(GtkWidget * widget,
                                 GdkEvent * event, gpointer user_data);

void on_passcancel_button_clicked(GtkButton * button, gpointer user_data);

void on_paraok_button_clicked(GtkButton * button, gpointer user_data);

void on_parapass_button_clicked(GtkButton * button, gpointer user_data);
void on_composeppone_button_clicked(GtkButton * button, gpointer user_data);

void on_composesend_button_clicked(GtkButton * button, gpointer user_data);

void on_composecancel_button_clicked(GtkButton * button, gpointer user_data);
void on_view_changed(GtkWidget * combobox, gpointer user_data);
void on_from_changed(GtkButton * button, gpointer user_data);
void on_attachadd_button_clicked(GtkButton * button, gpointer user_data);

void on_attachdel_button_clicked(GtkButton * button, gpointer user_data);



void on_getmail_button_clicked(GtkButton * button, gpointer user_data);

void on_compose_button_clicked(GtkButton * button, gpointer user_data);

void on_contacts_button_clicked(GtkButton * button, gpointer user_data);

void on_reply_button_clicked(GtkButton * button, struct email *mail);

void on_replyall_button_clicked(GtkButton * button, struct email *mail);

void on_forward_button_clicked(GtkButton * button, struct email *mail);

void on_del_button_clicked(GtkButton * button, struct email *mail);


void on_mail_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_account_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_folder_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_contacts_menu_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_get_mail_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_close_paranoy_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_cut_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_copy_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_paste_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_delete_mail_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_select_all_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_item1_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_preferences_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_view_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_mails_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_new_mail_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_reply_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_reply_all_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_forward_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_mail_as_new_activate(GtkMenuItem * menuitem, gpointer user_data);


void on_filter_from_mail_activate(GtkMenuItem * menuitem, gpointer user_data);


void on_showattach_button_clicked(GtkButton * button, gpointer user_data);

void on_addattach_button_clicked(GtkButton * button, gpointer user_data);

void on_delattach_button_clicked(GtkButton * button, gpointer user_data);

void on_cut_button_clicked(GtkButton * button, gpointer user_data);

void on_copy_button_clicked(GtkButton * button, gpointer user_data);

void on_paste_button_clicked(GtkButton * button, gpointer user_data);

void on_selall_button_clicked(GtkButton * button, gpointer user_data);

void on_delete_button_clicked(GtkButton * button, gpointer user_data);

void on_clear_button_clicked(GtkButton * button, gpointer user_data);

void on_fromfile_button_clicked(GtkButton * button, gpointer user_data);

void on_showattach_button_clicked(GtkButton * button, gpointer user_data);

void on_addattach_button_clicked(GtkButton * button, gpointer user_data);

void on_delattach_button_clicked(GtkButton * button, gpointer user_data);

void on_cut_button_clicked(GtkButton * button, gpointer user_data);

void on_copy_button_clicked(GtkButton * button, gpointer user_data);

void on_paste_button_clicked(GtkButton * button, gpointer user_data);

void on_selall_button_clicked(GtkButton * button, gpointer user_data);

void on_delete_button_clicked(GtkButton * button, gpointer user_data);

void on_clear_button_clicked(GtkButton * button, gpointer user_data);

void on_fromfile_button_clicked(GtkButton * button, gpointer user_data);




void on_newcancel_button_clicked(GtkButton * button, gpointer user_data);


GtkWidget *print_info_table();

void on_delacc_button_clicked(GtkButton * button, gpointer user_data);

void on_delacc_cancelbutton_clicked(GtkButton * button, gpointer user_data);

void toggle_smtp_auth_info();
