#include "../include.h"


// crea una finestra con tante status bar quanto il numero degli account
GtkWidget *
create_download_window()
{
  GtkWidget *downloadwin;
  GtkWidget *vbox;
  GtkWidget *separator;
  GtkWidget *label;
  char buff[BUFFER_REAL];
  int i;

  if (progress)
    free(progress);


  progress = (GtkWidget **) malloc(sizeof(GtkWidget *) * naccount);

  downloadwin = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_size_request(downloadwin, 300, naccount * 40);
  gtk_window_set_title((GtkWindow *) downloadwin, _(":: download ::"));
  gtk_window_set_position((GtkWindow *) downloadwin, GTK_WIN_POS_CENTER);
  gtk_widget_show(downloadwin);

  vbox = gtk_vbox_new(FALSE, 0);
  gtk_widget_show(vbox);
  gtk_container_add((GtkContainer *) downloadwin, vbox);

  for (i = 0; i < naccount; i++)
  {
    snprintf(buff, BUFFER_LEN, " -[ Download emails from %s ]- ",
             account[i]->host);
    label = gtk_label_new(_(buff));
    progress[i] = gtk_progress_bar_new();
    separator = gtk_hseparator_new();
    gtk_widget_show(label);
    gtk_widget_show(progress[i]);
    gtk_widget_show(separator);
    gtk_container_add((GtkContainer *) vbox, label);
    gtk_container_add((GtkContainer *) vbox, progress[i]);
    gtk_container_add((GtkContainer *) vbox, separator);
  }


  if (!downloading)
  {
    downloading = 1;
    pthread_create(&download_thread, NULL, (void *) download, NULL);
    // g_thread_create((GThreadFunc)download, NULL, FALSE, NULL);

  } else
    info(0, "  -[ paranoy is still downloading your email ]-");

  /*
   * while(down_flag) { pthread_cond_wait(&pop3event,download_thread); while
   * (g_main_context_iteration(NULL, FALSE)); }
   */
  return downloadwin;
}
