/*
 * Copyright (C) 2003  
 * paranoy project - paranox.sf.net - paranoy@autistici.org
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */

#include "include.h"




// create a new folder using 

struct folders *
new_folder(const char *name)
{
  nfolds++;
  folder =
    (struct folders **) realloc(folder, sizeof(struct folders *) * nfolds);
  folder[nfolds - 1] = (struct folders *) smalloc(sizeof(struct folders));
  folder[nfolds - 1]->name = strdup(name);
  folder[nfolds - 1]->head = NULL;
  folder[nfolds - 1]->nall = folder[nfolds - 1]->nnew =
    folder[nfolds - 1]->nold = 0;
  chdir(MAILDIR);
#ifdef USE_GTK
  if (gui == GTK)
  {
    GtkTreeIter fold_iter;
    char buff[30];

    if (fold_store)
    {
      gtk_tree_store_append((GtkTreeStore *) fold_store, &fold_iter, NULL);

      snprintf(buff, 29, "[%d/%d]", folder[nfolds - 1]->nnew,
               folder[nfolds - 1]->nall);
      gtk_tree_store_set((GtkTreeStore *) fold_store, &fold_iter, /* FOLD_ICON, 
                                                                   * icon, */ FOLD_NAME,
                         name, FOLD_NUM, buff, FOLD,
                         (gpointer) folder[nfolds - 1], -1);
    }
  }
#endif
  write_index();
  return folder[nfolds - 1];
}

void
parse_folder()
{
  ushort i = 0, le, n = 0;
  FILE *index;
  EVP_CIPHER_CTX ctx;
  struct email *mail;
  struct list *search, *l;
  char buff[BUFFER_REAL];
  char *p;

  nfolds = 0;

  logg("DENTRO PARSE_FOLDER\n");
  if (!MAILDIR)
    end
      ("What's happend? I can't find MAILDIR... remove ~/.paranoyrc and restart..\n");

  logg("maildir - apro  fold_index\n");
  if ((index = fopen("fold_index", "r")) == NULL)
    return;

  folder = (struct folders **) malloc(sizeof(struct folders *));
  crypto_init(&ctx, DECRYPT);
  le = readcline(&ctx, index, buff, BUFFER_LEN, NULL);
  while (le && strcmp(buff, "-----END-----"))
  {
    folder[i] = (struct folders *) malloc(sizeof(struct folders));
    folder[i]->name = strdup(buff);
    logg("maildir - nuovo folder %s\n", folder[i]->name);
    nfolds++;
    le = readcline(&ctx, index, buff, BUFFER_LEN, NULL);
    logg("dopo la reaadcline buff = %s e le = %d\n", buff, le);
    folder =
      (struct folders **) realloc(folder,
                                  sizeof(struct folders *) * (++i + 1));

    // logg ("ciccione!!!\n");
  }
  logg("maildir - %d folders prima del for\n", nfolds);

  for (; i > 0; i--)
  {
    logg("parse_folder - folder[%d] = %s\n", n, folder[n]->name);
    folder[n]->nnew = 0;
    folder[n]->nold = 0;
    folder[n]->nall = 0;
    folder[n]->head = NULL;

    // load index file
    if ((index = fopen(folder[n]->name, "r")) != NULL)
    {
      crypto_init(&ctx, DECRYPT);

      // nall
      readcline(&ctx, index, buff, BUFFER_LEN, NULL);

      folder[n]->nall = atoi(buff);
      logg("parse_folder - nall = %d - buff='%s'\n", folder[n]->nall, buff);

      // nnew
      readcline(&ctx, index, buff, BUFFER_LEN, NULL);
      folder[n]->nnew = atoi(buff);
      logg("parse_folder - nnew = %d\n , buff='%s\n'", folder[n]->nnew, buff);

      // nold
      readcline(&ctx, index, buff, BUFFER_LEN, NULL);
      folder[n]->nold = atoi(buff);
      logg("parse_folder - nold = %d\n", folder[n]->nold);

      le = readcline(&ctx, index, buff, BUFFER_LEN, NULL);
      logg("parse_folder - prima del while di load dell'index leggo '%s' \n",
           buff);
      while (le && strcmp(buff, "-----END-----"))
      {
        search = folder[n]->head;
        logg("parse_folder - dentro il while buff = '%s'\n", buff);
        mail = (struct email *) smalloc(sizeof(struct email));
        mail->from = NULL;
        mail->boundary = NULL;
        mail->mime = NOMIME;
        mail->subject = NULL;
        mail->body = NULL;
        mail->header = NULL;
        mail->row_len = NULL;
        mail->hlen = 0;
        mail->head_lines = 0;
        mail->body_lines = 0;
        mail->len = 0;
        mail->messageid = NULL;
        mail->inreplyto = NULL;
        mail->attach = NULL;
        mail->level = 0;
        mail->nto = 0;
        mail->to = NULL;
        mail->bcc = NULL;
        mail->nbcc = 0;
        mail->date = (struct tm *) malloc(sizeof(struct tm));
        mail->nattach = 0;
        // type
        mail->type = atoi(buff);
        logg("parse_folder il type e' '%d'\n", mail->type);

        // uidl
        readcline(&ctx, index, buff, BUFFER_LEN, &le);
        mail->uidl = (char *) malloc(le + 1);
        memcpy(mail->uidl, buff, le);
        *(mail->uidl + le) = 0;
        logg("parse_folder - il uidl e' '%s'\n", mail->uidl);

        // messageid
        readcline(&ctx, index, buff, BUFFER_LEN, &le);
        mail->messageid = (char *) malloc(le + 1);
        memcpy(mail->messageid, buff, le);
        *(mail->messageid + le) = 0;
        logg("parse_folder - il messageid e' '%s'\n", mail->messageid);

        // boundary
        readcline(&ctx, index, buff, BUFFER_LEN, &le);
        mail->boundary = (char *) malloc(le + 1);
        memcpy(mail->boundary, buff, le);
        *(mail->boundary + le) = 0;


        // nattach
        readcline(&ctx, index, buff, BUFFER_LEN, &le);
        mail->nattach = atoi(buff);

        // inreplyto
        readcline(&ctx, index, buff, BUFFER_LEN, &le);
        mail->inreplyto = (char *) malloc(le + 1);
        memcpy(mail->inreplyto, buff, le);
        *(mail->inreplyto + le) = 0;
        logg("parse_folder - l'inreplyto e' '%s'\n", mail->inreplyto);

        // subject
        readcline(&ctx, index, buff, BUFFER_LEN, &le);
        mail->subject = (char *) malloc(le + 1);
        memcpy(mail->subject, buff, le);
        *(mail->subject + le) = 0;
        logg("parse_folder - il subject e' '%s'\n", mail->subject);

        // from
        readcline(&ctx, index, buff, BUFFER_LEN, &le);
        mail->from = (char *) malloc(le + 1);
        memcpy(mail->from, buff, le);
        *(mail->from + le) = 0;
        logg("parse_folder - il from e' '%s'\n", mail->from);

        // to
        readcline(&ctx, index, buff, BUFFER_LEN, &le);
        mail->to = (char **) malloc(sizeof(char *));
        mail->to[0] = (char *) malloc(le + 1);
        memcpy(mail->to[0], buff, le);
        *(mail->to[0] + le) = 0;
        mail->nto = 1;
        logg("parse_folder - il to e' '%s'\n", mail->to[0]);


        // date
        readcline(&ctx, index, buff, BUFFER_LEN, &le);
        logg("parse_folder - la data e' '%s'\n", buff);
        p = buff;
        while (1)
        {
          p = strchr(p + 1, '.');
          if (!p)
            break;
          *p = 0;
        }
        mail->date->tm_sec = atoi(buff);
        mail->date->tm_min = atoi(buff + 3);
        mail->date->tm_hour = atoi(buff + 6);
        mail->date->tm_mday = atoi(buff + 9);
        mail->date->tm_mon = atoi(buff + 12);
        mail->date->tm_year = atoi(buff + 15);


        // add mail to lista
        logg("parse_folder - ora aggiungo la mail alla lista\n");
        if (!folder[n]->head)
        {
          folder[n]->head = (struct list *) smalloc(sizeof(struct list));
          folder[n]->head->prev = NULL;
          folder[n]->head->next = NULL;
          folder[n]->head->mail = mail;

        } else
        {
          logg("parse_folder - ora cerco se il messaggio ha padri\n");
          search = folder[n]->head;
          while (search)
          {
            if (!strcmp(search->mail->messageid, mail->inreplyto))
              break;
            search = search->next;
          }


          l = (struct list *) malloc(sizeof(struct list));
          l->mail = mail;
          if (!search)
          {
            logg("parse_folder - il messaggio nn ha padri\n");
            l->next = folder[n]->head;
            folder[n]->head->prev = l;
            l->prev = NULL;
            folder[n]->head = l;
          } else
          {
            logg("parse_folder - il messaggio ha padri, il level e' = %d\n",
                 search->mail->level);
            l->mail->level = search->mail->level + 1;

            if (search->next)
              search->next->prev = l;
            l->next = search->next;
            search->next = l;
            l->prev = search;
          }
        }
        le = readcline(&ctx, index, buff, BUFFER_LEN, NULL);
      }
    }
    n++;
  }
}


void
write_index()
{
  ushort i, len, n;
  EVP_CIPHER_CTX ctx;
  FILE *index;
  char buff[BUFFER_REAL];
  struct list *l = NULL;

  logg("\n\n\nwrite_index\n");
  chdir(MAILDIR);

  // writes folder lists
  if ((index = fopen("fold_index", "w")) != NULL)
  {

    crypto_init(&ctx, ENCRYPT);
    logg("dopo crypto_init nfolds = %d\n", nfolds);
    for (i = 0; i < nfolds; i++)
    {

      logg("dentro il ciclo\n");
      len = snprintf(buff, BUFFER_LEN, "%s\n", folder[i]->name);
      cfwrite(&ctx, buff, len, 0, index);
    }
    logg("dopo il ciclo dove scrivo le robe\n");
    len = snprintf(buff, BUFFER_LEN, "-----END-----");
    cfwrite(&ctx, buff, len, 1, index);
  } else
  {
    info(2, "Error while writing file index\n");
    return;
  }

  logg("ora devo scrivere tutti i files\n");
  // writes index files
  for (i = 0; i < nfolds; i++)
  {
    crypto_init(&ctx, ENCRYPT);
    logg("write_index - apro in scrittura il file %s\n", folder[i]->name);
    if ((index = fopen(folder[i]->name, "w")) != NULL)
    {

      l = folder[i]->head;
      len = n = folder[i]->nall;
      for (; n > 0; n--)
      {
        if (l->mail->type & DEL)
        {
          ranza(l->mail->uidl);
          len--;
        }
        l = l->next;
        if (!l)
          break;

      }

      n = snprintf(buff, BUFFER_LEN, "%d\n%d\n%d\n", len,
                   folder[i]->nnew, folder[i]->nold);
      cfwrite(&ctx, buff, n, 0, index);
      l = folder[i]->head;
      for (n = 0; n < folder[i]->nall; n++)
      {
        // if mail is not deleted
        if (!(l->mail->type & DEL))
        {
          len = snprintf(buff, BUFFER_LEN, "%d\n", l->mail->type);
          cfwrite(&ctx, buff, len, 0, index);
          logg("Scrivo '%s' %d\n ", buff, len);


          len =
            snprintf(buff, BUFFER_LEN, "%s\n",
                     l->mail->uidl ? l->mail->uidl : "");
          cfwrite(&ctx, buff, len, 0, index);
          logg("Scrivo '%s' %d\n ", buff, len);

          len =
            snprintf(buff, BUFFER_LEN, "%s\n",
                     l->mail->messageid ? l->mail->messageid : "");
          cfwrite(&ctx, buff, len, 0, index);
          logg("Scrivo '%s' %d\n ", buff, len);

          len =
            snprintf(buff, BUFFER_LEN, "%s\n",
                     l->mail->boundary ? l->mail->boundary : "");
          cfwrite(&ctx, buff, len, 0, index);
          logg("Scrivo '%s' %d\n ", buff, len);

          len = snprintf(buff, BUFFER_LEN, "%d\n", l->mail->nattach);
          cfwrite(&ctx, buff, len, 0, index);
          logg("Scrivo '%s' %d\n ", buff, len);

          len =
            snprintf(buff, BUFFER_LEN, "%s\n",
                     l->mail->inreplyto ? l->mail->inreplyto : l->mail->from);
          cfwrite(&ctx, buff, len, 0, index);
          logg("Scrivo '%s' %d\n ", buff, len);

          len =
            snprintf(buff, BUFFER_LEN, "%s\n",
                     l->mail->subject ? l->mail->subject : "");
          cfwrite(&ctx, buff, len, 0, index);
          logg("Scrivo '%s' %d\n ", buff, len);

          len =
            snprintf(buff, BUFFER_LEN, "%s\n",
                     l->mail->from ? l->mail->from : "");
          cfwrite(&ctx, buff, len, 0, index);
          logg("Scrivo '%s' %d\n ", buff, len);

          len =
            snprintf(buff, BUFFER_LEN, "%s\n",
                     l->mail->to[0] ? l->mail->to[0] : "");
          cfwrite(&ctx, buff, len, 0, index);
          logg("Scrivo '%s' %d\n ", buff, len);


          struct tm *t = l->mail->date;

          len =
            snprintf(buff, BUFFER_LEN, "%2d.%2d.%2d.%2d.%2d.%4d\n", t->tm_sec,
                     t->tm_min, t->tm_hour, t->tm_mday, t->tm_mon,
                     t->tm_year);

          logg("scrivo la data %s\n", buff);
          cfwrite(&ctx, buff, len, 0, index);

        }
        l = l->next;
        if (!l)
          break;

      }
    }
    len = snprintf(buff, BUFFER_LEN, "-----END-----");
    cfwrite(&ctx, buff, len, 1, index);
    logg("scrivo e kiudo l'index %d\n", len);
  }
}



struct folders *
search_folder(const char *name)
{
  byte i;

  logg("nfolds = %d\n", nfolds);
  for (i = 0; i < nfolds; i++)
  {
    logg("sono dentro e i = %d\n", i);
    logg("Controllo folder[%d] = %s\n", i, folder[i]->name);
    if (!strcmp(folder[i]->name, name))
    {
      logg("dentro search folder ho trovato %s e head = %p\n", name,
           folder[i]->head);
      return folder[i];
    }
  }
  logg("vado di return\n");
  return NULL;
}




void
save_mail(struct email *mail, byte type)
{
  FILE *file;
  EVP_CIPHER_CTX ctx;
  char buff[BUFFER_REAL];
  ushort l;
  ushort i;
  struct lines *cur = text;

  // debug
  snprintf(buff, BUFFER_LEN, "deb%s", mail->uidl);
  debugfile = fopen(buff, "w");

  if ((file = fopen(mail->uidl, "w")) == NULL)
    return;                     // TOFIX ://

  crypto_init(&ctx, ENCRYPT);

  // write attachments information
  l = snprintf(buff, BUFFER_LEN, "%d\n", mail->mime);

  cfwrite(&ctx, buff, l, 0, file);

  fwrite(buff, l, 1, debugfile);

  if (mail->mime == MIME)
  {
    l = snprintf(buff, BUFFER_LEN, "%d\n", mail->nattach);
    cfwrite(&ctx, buff, l, 0, file);
    fwrite(buff, l, 1, debugfile);

    l = snprintf(buff, BUFFER_LEN, "%d\n", mail->txt_attach);
    cfwrite(&ctx, buff, l, 0, file);
    fwrite(buff, l, 1, debugfile);

    logg("dentro save_mail il numero di allegati e' %d\n", mail->nattach);
    for (i = 0; i < mail->nattach; i++)
    {
      l =
        snprintf(buff, BUFFER_LEN, "%s\n",
                 mail->attach[i]->name ? mail->attach[i]->name : "");
      cfwrite(&ctx, buff, l, 0, file);
      fwrite(buff, l, 1, debugfile);
      l = snprintf(buff, BUFFER_LEN, "%d\n", mail->attach[i]->type);
      cfwrite(&ctx, buff, l, 0, file);
      fwrite(buff, l, 1, debugfile);
      l = snprintf(buff, BUFFER_LEN, "%ld\n", mail->attach[i]->offset);
      cfwrite(&ctx, buff, l, 0, file);
      fwrite(buff, l, 1, debugfile);
      l=snprintf(buff,BUFFER_LEN,"%ld\n",mail->attach[i]->length);
      cfwrite(&ctx, buff, l, 0, file);
    }
  }


  i = 0;

  while (mail->header[i])
  {
    l = snprintf(buff, BUFFER_LEN, "%s\n", mail->header[i++]);
    logg("save_mail - scrivo l'header '%s' \n", buff);
    cfwrite(&ctx, buff, l, 0, file);
    fwrite(buff, l, 1, debugfile);
  }

  logg("dopo il cazzo di ciclo ke scrive gli headers\n");
  l = snprintf(buff, BUFFER_LEN, "\n\n");
  cfwrite(&ctx, buff, l, 0, file);
  fwrite(buff, l, 1, debugfile);


  if (!type)                    // write as array
  {
    logg("maildir - inizio il ciclo, %d righe\n", mail->body_lines);
    i = 0;
    while (i < mail->body_lines)
    {
      strncpy(buff, mail->body[i], (size_t) mail->row_len[i]);
      *(buff + mail->row_len[i]) = '\n';
      *(buff + mail->row_len[i] + 1) = 0;
      logg("maildir - lancio cfwrite %d '%s'\n", mail->row_len[i], buff);
      cfwrite(&ctx, buff, (int) mail->row_len[i] + 1, 0, file);
      fwrite(buff, mail->row_len[i] + 1, 1, debugfile);
      // *(buff + mail->row_len[i]) = 0;
      logg("maildir - dopo cfwrite\n");
      i++;
    }
    logg("maildir - dopo il ciclo i = %d\n", i);
  }
  // write as list
  else
  {
    do
    {
      logg("prima del while dentro save_mail scrivo %d chars '%s'\n", cur->l,
           cur->data);
      cfwrite(&ctx, cur->data, cur->l ? cur->l : 1, 0, file);
      fwrite(cur->data, cur->l, 1, debugfile);
      cur = cur->next;

    }
    while (cur);
  }

  l = snprintf(buff, BUFFER_LEN, "\n");
  cfwrite(&ctx, buff, l, 1, file);
  fwrite(buff, l, 1, debugfile);
  fclose(debugfile);
}

void
load_mail(struct email *mail)
{
  FILE *file;
  EVP_CIPHER_CTX ctx;
  char buff[BUFFER_REAL];
  ushort a;
  ushort i;


  if ((file = fopen(mail->uidl, "r")) == NULL)
  {
    info(1, "Error while reading email!");
    return;                     // TOFIX
  }
  crypto_init(&ctx, DECRYPT);

  // legge se e' mime o meno
  readcline(&ctx, file, buff, BUFFER_LEN, NULL);
  mail->mime = atoi(buff);

  if (mail->mime == MIME)
  {
    readcline(&ctx, file, buff, BUFFER_LEN, NULL);
    mail->nattach = atoi(buff);
    readcline(&ctx, file, buff, BUFFER_LEN, NULL);
    mail->txt_attach = atoi(buff);
    mail->attach =
      (struct attachments **) malloc(sizeof(struct attachments *) *
                                     mail->nattach);
    for (i = 0; i < mail->nattach; i++)
    {
      mail->attach[i] =
        (struct attachments *) malloc(sizeof(struct attachments));
      // attachment name
      readcline(&ctx, file, buff, BUFFER_LEN, NULL);
      mail->attach[i]->name = strdup(buff);
      // type
      readcline(&ctx, file, buff, BUFFER_LEN, NULL);
      mail->attach[i]->type = atoi(buff);
      // offset
      readcline(&ctx, file, buff, BUFFER_LEN, NULL);
      mail->attach[i]->offset = atoi(buff);
			// length
      readcline(&ctx, file, buff, BUFFER_LEN, NULL);
      mail->attach[i]->length = atoi(buff);
			

    }
  }
  // read headers
  readcline(&ctx, file, buff, BUFFER_LEN, NULL);
  while (buff[0] != 0)
  {
    logg("Leggo heads file.... %d '%s'\n", mail->head_lines, buff);
    // alloca una nuova riga
    mail->header =
      (char **) realloc(mail->header,
                        sizeof(char *) * (mail->head_lines + 1));
    logg("dopo la realloc %p\n", mail->header);
    mail->header[mail->head_lines] = strdup(buff);
    logg("dopo la strdup %p\n", mail->header[mail->head_lines]);
    mail->head_lines++;
    logg("vado di readcline\n");
    readcline(&ctx, file, buff, BUFFER_LEN, NULL);
  }
  logg("dopo la lettura degli headers  mail = %p e body_lines = %d\n", mail,
       mail->body_lines);

  // read body
  a = 1;
  while (a)
  {
    logg("dentro il while di lettura del body\n");
    mail->body =
      (char **) realloc(mail->body, sizeof(char *) * (mail->body_lines + 1));
    logg("dopo la realloc del body\n");
    mail->row_len =
      (ushort *) realloc(mail->row_len,
                         sizeof(ushort) * (mail->body_lines + 1));
    logg("dopo la realloc del row_len\n");
    a =
      readcline(&ctx, file, buff, BUFFER_LEN,
                &mail->row_len[mail->body_lines]);
    logg("dopo readcline\n");
    logg("Leggo body.... %d '%s'\n", mail->row_len[mail->body_lines], buff);
    if (!a)
		{
      mail->body[mail->body_lines] = NULL;
			mail->row_len[mail->body_lines]=0;
		}
    else
    {
      mail->body[mail->body_lines] = strdup(buff);
      mail->body_lines++;
    }
  }
	logg("alla fine di load_mail\n");
}

void
free_mail_body(struct email *mail)
{

  unsigned long int l = 0;

  logg("CALLING head_lines = %d\n", mail->head_lines);

  while (l < mail->head_lines)
    free(mail->header[l++]);

  free(mail->header);

  l = 0;

  while (l < mail->body_lines)
    free(mail->body[l++]);
  free(mail->body);

  l = 0;

  while (l < mail->nattach)
  {
    if (mail->attach[l]->name)
      free(mail->attach[l]->name);
    free(mail->attach[l]);
    l++;
  }
  if (mail->attach)
    free(mail->attach);

  free(mail->row_len);

  mail->header = mail->body = NULL;
  mail->row_len = NULL;
  mail->body_lines = 0;
  mail->head_lines = 0;


}
