/*
 * Copyright (C) 2003  
 * paranoy project - paranox.sf.net - paranoy@autistici.org
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */

#include "include.h"

/*
 * secure delete of a file (yes....obsolete....but will be optional)
 * read the Gutmann's paper for more info
 *
 */
void
ranza(char *file)
{
  FILE *f;
  struct stat st;
  off_t size;
  char cs[2046];
  unsigned long int i;
  unsigned int round, c;
  unsigned char gut[27][3] = {
    {"\x55\x55\x55"}, {"\xaa\xaa\xaa"}, {"\x92\x49\x24"},
    {"\x49\x24\x92"}, {"\x24\x92\x49"}, {"\x00\x00\x00"},
    {"\x11\x11\x11"}, {"\x22\x22\x22"}, {"\x33\x33\x33"},
    {"\x44\x44\x44"}, {"\x55\x55\x55"}, {"\x66\x66\x66"},
    {"\x77\x77\x77"}, {"\x88\x88\x88"}, {"\x99\x99\x99"},
    {"\xaa\xaa\xaa"}, {"\xbb\xbb\xbb"}, {"\xcc\xcc\xcc"},
    {"\xdd\xdd\xdd"}, {"\xee\xee\xee"}, {"\xff\xff\xff"},
    {"\x92\x49\x24"}, {"\x49\x24\x92"}, {"\x24\x92\x49"},
    {"\x6d\xb6\xdb"}, {"\xb6\xdb\x6d"}, {"\xdb\x6d\xb6"}
  };

  if (lstat(file, &st))
    return;

  if ((f = fopen(file, "r+")) == NULL)
    return;

  size = st.st_size;
  c = round = (int) size / 2045;

  memset(cs, 1, 2045);
  // first overwrite
  for (; c > 0; c--)
    fputs(cs, f);


  // writes 4 random bytes
  for (i = 0; i < 4; i++)
  {
    rewind(f);
    memset(cs, rand() % 256, 2045);
    c = round;
    for (; c > 0; c--)
      fputs(cs, f);
  }

  // write Gutmann values
  for (i = 0; i < 27; i++)
  {
    for (c = 0; c < 2045; c += 3)
    {
      cs[c] = gut[i][0];
      cs[c + 1] = gut[i][1];
      cs[c + 2] = gut[i][2];
    }
    c = round;
    for (; c > 0; c--)
      fputs(cs, f);
  }

  srand((unsigned int) time(NULL));
  // writes 4 random bytes
  for (i = 0; i < 4; i++)
  {
    rewind(f);
    memset(cs, rand() % 256, 2045);
    c = round;
    for (; c > 0; c--)
      fputs(cs, f);
  }


  fclose(f);
  remove(file);
}
